package com.Geister;

import java.net.Socket;

import com.PlayerInfoDLL.PlayerInfo;

public class Player {

    private final Socket playerSocket;
    private final String playerName;   //玩家名稱
    private final String playerKind;   //0: AI, 1: human
    private final String socketRemoteEndpoint;

    private boolean isWaitingReadData = false;
    private boolean isResponse = true;
    private boolean isDrawOffer = false;

    private boolean isAlive = true;
    private boolean isSocketClose = false;

    Player(PlayerInfo playerInfo)
    {
        playerSocket = playerInfo.socket;
        playerName = playerInfo.name;
        playerKind = playerInfo.playerKind;
        socketRemoteEndpoint = playerInfo.socket == null ? "" : playerInfo.socket.getRemoteSocketAddress() + "";
    }

    void setIsWaitingReadData(boolean isWaitingReadData)
    {
        this.isWaitingReadData = isWaitingReadData;
    }

    void setIsResponse(boolean isResponse)
    {
        this.isResponse = isResponse;
    }

    void setIsDrawOffer(boolean isDrawOffer)
    {
        this.isDrawOffer = isDrawOffer;
    }

    void setIsAlive(int timeOutMilliSecond)
    {
        /*if (isSocketClose)
        {
            isAlive = false;
        }
        else if (!playerSocket.Connected || playerSocket.Poll(timeOutMilliSecond, SelectMode.SelectRead) && playerSocket.Available == 0)
        {
            isAlive = false;
        }*/
    }

    void closeSocket()
    {
        if (!isSocketClose)
        {
            // 各個棋類不需呼叫 socket.Close()
            // playerSocket.Shutdown(SocketShutdown.Both);
            // playerSocket.Disconnect(false);
            // playerSocket.Close();
            isSocketClose = true;
            isAlive = false;
        }
    }

    Socket getPlayerSocket()
    {
        return playerSocket;
    }

    String getPlayerName()
    {
        return playerName;
    }

    String getPlayerKind()
    {
        return playerKind;
    }

    String getSocketRemoteEndpoint()
    {
        return socketRemoteEndpoint;
    }

    boolean getIsWaitingReadData()
    {
        return isWaitingReadData;
    }

    boolean getIsResponse()
    {
        return isResponse;
    }

    boolean getIsDrawOffer()
    {
        return isDrawOffer;
    }

    boolean getIsAlive()
    {
    	return isAlive = (isAlive == false ? false : !playerSocket.isInputShutdown());
    }

    boolean getIsSocketClose()
    {
        return isSocketClose;
    }
}
