package com.Geister;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.text.DateFormatSymbols;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class ProcessRecoder {//保存日誌信息
	
	private Object SyncRoot;

    private String processLog = "";

    ProcessRecoder()
    {
    	SyncRoot = new Object();
    }

    void addProcessLog(String message)
    {
    	synchronized (SyncRoot) {
    		processLog += new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.SSS").format(new Date()) + ",  " + message + "\n";
		}
    }

    void resetProcessRecoder()
    {
    	synchronized (SyncRoot) {
    		processLog = "";
		}
    }

    void saveProcessLog(String judgeResult, String saveSituation, List<Player> playerName, String gameStartTimeStamp)
    {
    	Date date = new  Date();

        String folderName = String.format("ProcessLog" + File.separator + new SimpleDateFormat("yyyy" + File.separator + "MM" + File.separator + "dd").format(date));
        if (!saveSituation.equals("Normal"))
        {
            folderName += "\\" + saveSituation;
        }

        String boardEndingRecordFileName = "";
        for (Player player : playerName)
        {
            boardEndingRecordFileName += String.format("%s VS ", player.getPlayerName());
        }
        boardEndingRecordFileName = boardEndingRecordFileName.substring(0, boardEndingRecordFileName.length() - 3);
        boardEndingRecordFileName += String.format("(%s)-%s_%s.txt", new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss").format(date), judgeResult, saveSituation);

        File file = new File(folderName);
        if (!file.exists()){ //檢查是否資料夾存在,如果存在就不開新的資料夾
            file.mkdirs();     //資料夾不存在,開新資料夾
        }

        OutputStream outputStream;
        try {
        	outputStream = new FileOutputStream(folderName + "\\" + boardEndingRecordFileName);
            String rowOfBoardEndingRecord;
            
            SimpleDateFormat format = new SimpleDateFormat("K:ma MMM d, y", Locale.ENGLISH);
    		DateFormatSymbols symbols = new DateFormatSymbols(Locale.ENGLISH);
            // override symbols
            symbols.setAmPmStrings(new String[] { "am", "pm" });
            format.setDateFormatSymbols(symbols);
            String start_time = format.format(new Date(Long.parseLong(gameStartTimeStamp)));
            
            rowOfBoardEndingRecord = String.format("%s\n", start_time);
            outputStream.write(rowOfBoardEndingRecord.getBytes(StandardCharsets.UTF_8));
            
            String[] processLogArray = processLog.split("\n");
            for (String processLogItem : processLogArray)
            {
            	rowOfBoardEndingRecord = String.format("%s\n", processLogItem);
                outputStream.write(rowOfBoardEndingRecord.getBytes(StandardCharsets.UTF_8));
            }
            outputStream.flush();
            outputStream.close();
            
		} catch (Exception exception) {
			exception.printStackTrace();
		}
    }

    private static Lock saveToErrorLogSyncRoot = new ReentrantLock();
    static void saveToErrorLog(String message)
    {
    	try {
    		saveToErrorLogSyncRoot.lock();
    		Date date = new  Date();
    		String timeString = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss").format(new Date());
            String folderName = File.separator + "RoomMJErrorLog";
            String fileName = timeString + "_" + "RoomMJErrorLog.txt";

            File file = new File(folderName);
            if (!file.exists()){ //檢查是否資料夾存在,如果存在就不開新的資料夾
                file.mkdirs();     //資料夾不存在,開新資料夾
            }

            OutputStream outputStream;
            try {
            	outputStream = new FileOutputStream(folderName + "\\" + fileName);
                String rowOfBoardEndingRecord;
                
                rowOfBoardEndingRecord = String.format("%s, %s\n", timeString, message);
                outputStream.write(rowOfBoardEndingRecord.getBytes(StandardCharsets.UTF_8));
                
                outputStream.flush();
                outputStream.close();
                
    		} catch (Exception exception) {
    			exception.printStackTrace();
    		}
		} finally {
			saveToErrorLogSyncRoot.unlock();
		}
    }
}
