package com.Geister;

public class RoomGSTJudgement {
	static final char[] chessName = new char[] { '-', 'R', 'B', 'X', 'r', 'b' };
    static final int[] chessId = new int[] { 0, 1, 2, 3, 4, 5 };
    static final char[][] chessNameLevel = new char[][]//能吃對方的甚麼棋
    {
        new char[] { },                                //空子
         
        new char[] { 'r', 'b' },   //紅
        new char[] { 'r', 'b' },   //藍
        
        new char[] { },                                //未知棋  
        new char[] { 'R', 'B' },   //紅
        new char[] { 'R', 'B' }   //藍
        
    };
    static final int[][] chessIdLevel = new int[][]//能吃的棋編號
    {
        new int[] { },                         
        new int[] { 4, 5 },   
        new int[] { 4, 5 },  

        new int[] { },                         
        new int[] { 1, 2 },     
        new int[] { 1, 2 }
        
    };


    static final String MoveChess = "MoveChess";
    static final String CaptureChess = "CaptureChess";
    static final String ChessEscape = "ChessEscape";
    static final String IllegalAction = "IllegalAction";

    static final String NoBlueGhost = "NoBlueGhost";
    static final String NoRedGhost = "NoRedGhost";
    static final String GamePlyLimitDraw = "GamePlyLimitDraw";
    static final String TimeOut = "TimeOut";

    static final String SocketBroken = "SocketBroken";
    static final String Resign = "Resign";
    static final String DrawOffer = "DrawOffer";
    static final String Abort = "Abort";

    private final int setSecond;               //時間長度
    private final int plySecondLimit;          //計時方式(0: 回合制 or 大於0: 單手制)
    private final int groupPly;                //幾手共用
    private final int maxGamePlyCount;       //和局手數

    RoomGSTJudgement(String gameData)
    {
        String[] gameDataArray = gameData.split(",");
        setSecond = Integer.parseInt(gameDataArray[0]);
        plySecondLimit = Integer.parseInt(gameDataArray[1]);
        groupPly = Integer.parseInt(gameDataArray[2]);
        maxGamePlyCount = Integer.parseInt(gameDataArray[3]);
    }
    
    String moveChess(int gamePlyCount, int whoseTurn)
    {
    	
        String tempJudgeResult = "";
	    if (gamePlyCount >= maxGamePlyCount)
	    {
	        tempJudgeResult = String.format("%s,%d", RoomGSTJudgement.GamePlyLimitDraw, whoseTurn + 1);
	    }
        
        return tempJudgeResult;
    }
    

    String captureChess(String player, int[] remainAllChessCount, int[][] chessBoard, int whoseTurn)
    {
    	String tempJudgeResult = ""; //tempJudgeResult = "RoomGSTJudgement, loser"

        if (isNoBlueGhost(remainAllChessCount, chessBoard, player)) //檢查敵方還有沒有藍鬼
        {
            tempJudgeResult = String.format("%s,%d", RoomGSTJudgement.NoBlueGhost, 2 - whoseTurn);  //2 - whoseTurn 為敵方
        
        }else if (isNoRedGhost(remainAllChessCount, chessBoard, player)) //檢查敵方還有沒有紅鬼
        {
        	tempJudgeResult = String.format("%s,%d", RoomGSTJudgement.NoRedGhost, whoseTurn + 1);  
        }
        return tempJudgeResult;
    }
    
    String chessEscape(int escapeChess, int whoseTurn) {
    	String tempJudgeResult = RoomGSTJudgement.IllegalAction;
    	if (escapeChess != 0) {
    		tempJudgeResult = String.format("%s,%d", RoomGSTJudgement.ChessEscape, 2 - whoseTurn);// "JudgeResult,輸家(1:P1, 2:P2)"
    	}
    	return tempJudgeResult;
    }

    Object[] checkTimeOut(long usedMilliSecond, int groupPlyCount, int whoseTurn)
    {
    	String tempJudgeResult = "";
		Object[] objects = {
			tempJudgeResult,
			usedMilliSecond,
			groupPlyCount
		};
		
        if (setSecond == 0 && plySecondLimit == 0 && groupPly == 0) //不計時
        {
            return objects;
        }

        // 改成setSecond用完後，每手需在plySecondLimit內下出
        long diffTime = usedMilliSecond - setSecond * 1000;
        if (diffTime > 0 && diffTime <= plySecondLimit * 1000) {
        	usedMilliSecond = setSecond * 1000;
        }
        else if (diffTime > plySecondLimit * 1000) {
        	tempJudgeResult = String.format("%s,%d", RoomGSTJudgement.TimeOut, whoseTurn + 1);
	         // 超時重置時間
			usedMilliSecond = setSecond * 1000;
			groupPlyCount = 0;
        }
        else if (diffTime <= 0 && groupPly > 0) {
        	groupPlyCount += 1;
        	if (groupPlyCount >= groupPly)
        	{
        		usedMilliSecond = setSecond * 1000;
        		groupPlyCount = 0;
          	}
        }
        
        objects[0] = tempJudgeResult;
		objects[1] = usedMilliSecond;
		objects[2] = groupPlyCount;
        return objects;
    }

    String getActionName(int[] x, int[] y, int[][] chessBoard, String player)
    {
        String actionName = RoomGSTJudgement.IllegalAction; //若以下所有合法步皆不符合，則為不合法步
        if (x[0] == 6 || y[0] == 6) return actionName;
        int oldChessId = chessBoard[y[0]][x[0]];
        if (player.equals("P1") && oldChessId >= 1 && oldChessId <= 2 || player.equals("P2") && oldChessId >= 4 && oldChessId <= 5) //輪P1且動P1陣營 或 輪P2且動P2陣營
        {	
        	if (x[1] == 8 && y[1] == 8)
            {
            	actionName = RoomGSTJudgement.ChessEscape;
            	return actionName;
            }
        	
        	if (!(x[1] <= 5 && x[1] >= 0 &&  y[1] <= 5 && y[1] >= 0)) return actionName;
        	
        	int[] twoChessId = { oldChessId, chessBoard[y[1]][x[1]] }; //twoChessId[0] = oldChessId, twoChessId[1] = newChessId
            int xDisplacement = x[0] < x[1] ? (x[1] - x[0]) : (x[0] - x[1]);
            int yDisplacement = y[0] < y[1] ? (y[1] - y[0]) : (y[0] - y[1]);  
            if (twoChessId[1] == 0) //目的地為空子，Move
            {
                if ((xDisplacement + yDisplacement) == 1)
                {
                    actionName = RoomGSTJudgement.MoveChess;
                }
            }
            else //目的地不為空子，Capture
            {	
            	for (int i = 0; i < chessIdLevel[twoChessId[0]].length; i++)
            	{
            		if (twoChessId[1] == chessIdLevel[twoChessId[0]][i] && (xDisplacement + yDisplacement) == 1)
            		{
            			actionName = RoomGSTJudgement.CaptureChess;
            			break;
            		}
            	}
//                if((player.equals("P1") && twoChessId[1] >= 4 && twoChessId[1] <= 5) || (player.equals("P2") && twoChessId[1] >= 1 && twoChessId[1] <= 2))//目的地是否有敵方旗子
//                {
//                	actionName = RoomGSTJudgement.CaptureChess;
//                }
            }
        }
        return actionName;
    }


    int getSetSecond()
    {
        return setSecond;
    }

    int getPlySecondLimit()
    {
        return plySecondLimit;
    }

    int getGroupPly()
    {
        return groupPly;
    }

    int getMaxGamePlyCount()
    {
        return maxGamePlyCount;
    }

    //敵人是否還有藍鬼
    private boolean isNoBlueGhost(int[] remainAllGeisterCount, int[][] chessBoard, String player)
    {
        int chessCount = 0;
        String nextPlayer = player.equals("P1") ? "P2" : "P1";
        int oppBlueGhostId = -1;
        
        oppBlueGhostId = (nextPlayer.equals("P1")) ? 2 : 5;
        for (int i = 0; i < chessBoard.length; i++)
        {
            for (int j = 0; j < chessBoard[i].length; j++)
            {
                if (chessBoard[i][j] == oppBlueGhostId)
                {
                    chessCount += 1;
                }
            }
        }
        for (int i = 0; i < remainAllGeisterCount.length; i++)
        {
            if (i == oppBlueGhostId)
            {
                chessCount += remainAllGeisterCount[i];
            }
        }
        return chessCount == 0;
    }
    //敵人是否還有紅鬼
    private boolean isNoRedGhost(int[] remainAllGeisterCount, int[][] chessBoard, String player)
    {
        int chessCount = 0;
        int oppRedGhostId = -1;
        String nextPlayer = player.equals("P1") ? "P2" : "P1";
        oppRedGhostId = (nextPlayer.equals("P1")) ? 1 : 4;
        for (int i = 0; i < chessBoard.length; i++)
        {
            for (int j = 0; j < chessBoard[i].length; j++)
            {
                if (chessBoard[i][j] == oppRedGhostId)
                {
                    chessCount += 1;
                }
            }
        }
        for (int i = 0; i < remainAllGeisterCount.length; i++)
        {
            if (i == oppRedGhostId)
            {
                chessCount += remainAllGeisterCount[i];
            }
        }
        return chessCount == 0;
    }
    
}

