package com.Geister;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.Random;
import java.util.Set;
import java.util.LinkedHashSet;

public class RoomGSTTable {
	private int[] remainAllChessCount;
    private int[] retainAllChessCount;
    private int[] remainGhostCount;
    private int[] GhostCodeLocation; //{A,B,C,D,E,F,G,H,a,b,c,d,e,f,g,h} 0-7:P1 8-15:P2
    private int[] GhostCodeColor; //{A,B,C,D,E,F,G,H,a,b,c,d,e,f,g,h} 1:RED 2:BLUE
    private int[][] chessBoard;
    private int[][] customChessBoard;
    private int escapeChess;

    private int stepCount = 0;
    private String[] stepArray, timeArray, eatArray;
    private String gameStarted; //幽靈棋：第一步是否已著手，0：還沒 1：已著手  原:firstcolor
    private String judgeResult;
    private String Score;

    private String gameStartTimeStamp;     //廣播 gameStart 的 timeStamp
    private String boardEndingRecord;

    // 這裡的player1, player2沿用room的意思 (player1 是先手, player2 是後手)
    private String[] player = new String[] { "P1", "P2" };
    private long[] usedMilliSecond = new long[] { 0, 0 }; //usedMilliSecond[0] = player1UsedMilliSecond, usedMilliSecond[1] = player2UsedMilliSecond
    private int[] groupPlyCount = new int[] { 0, 0 };     //計數幾手共用
    private int MaxPlyCount = 0;

    private boolean isWaitingFirstPly = true;

    RoomGSTTable()
    {
        resetRoomGSTTable();
    }

    void resetRoomGSTTable()
    {		
//    	remainAllChessCount = new int[] { 0, 1,1,1,1,1,1,1,1, 16,1,1,1,1,1,1,1,1};
    	//0,(A,B,C,D)紅,(E,F,G,H)藍,16,(a,b,c,d)紅,(e,f,g,h)藍
//    	retainAllChessCount = new int[] { 0, 0, 0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
//        remainGhostCount = new int[] {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    	remainAllChessCount = new int[] { 0, 4, 4, 16, 4, 4};  // 
    	retainAllChessCount = new int[] { 0, 0, 0, 0, 0, 0};
    	remainGhostCount = new int[] {4, 4, 4, 4};
    	GhostCodeLocation = new int[] {25, 26, 27, 28, 31, 32, 33, 34, 10, 9, 8, 7, 4, 3, 2, 1};
    	GhostCodeColor = new int[] {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2};
    	
    	//給的座標是(x, y)=(col, row), 存取是用(row, col)
        chessBoard = new int[][]
        {
            new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 0, 0, 0, 0, 0},
            new int[] {0, 0, 0, 0, 0, 0},
            new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 3, 3, 3, 3, 0}
        };
        customChessBoard = new int[][]
        {
        	new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 0, 0, 0, 0, 0},
            new int[] {0, 0, 0, 0, 0, 0},
            new int[] {0, 3, 3, 3, 3, 0},
            new int[] {0, 3, 3, 3, 3, 0}
        };
        
        escapeChess = 0;
        
        stepCount = 0;
        stepArray = new String[1000];
        timeArray = new String[1000];
        eatArray = new String[1000];
        gameStarted = "0";
        judgeResult = "";
        Score = "0,0";

        gameStartTimeStamp = "0";
        boardEndingRecord = "";
        player = new String[] { "P1", "P2" };
        usedMilliSecond = new long[] { 0, 0 };
        groupPlyCount = new int[] { 0, 0 };
        MaxPlyCount = 0;
        isWaitingFirstPly = true;
//        remainAllChessCount = new int[] { 0, 1, 2, 2, 2, 2, 2, 5, 32, 1, 2, 2, 2, 2, 2, 5 };
//        retainAllChessCount = new int[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
//        remainGhostCount = new int[] { 1, 2, 2, 2, 2, 2, 5, 1, 2, 2, 2, 2, 2, 5 };
//    	chessBoard = new int[][]
//    	        {
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8}
//    	        };
//    	        customChessBoard = new int[][]
//    	        {
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8},
//    	            new int[] {8, 8, 8, 8}
//    	        };

        
    }

    boolean setChessBoardAndRemainGhostCount(String strChessBoard, String strremainGhostCount)
    {
        String[] chessBoardArray = strChessBoard.split(",");
        String[] remainGhostCountStr = strremainGhostCount.split(",");
        for(int i = 0; i < remainGhostCountStr.length; i++) {
        	remainGhostCount[i] = Integer.parseInt(remainGhostCountStr[i]);
        }
        
//        int[] liveChessCount = { 0, 0, 0, 0 };  //不變更功能的話，在幽靈棋的作用是活著的棋數
        for (int i = 0; i < chessBoard.length; i++)
        {
            for (int j = 0; j < chessBoard[i].length; j++)
            {
                //chessBoard[chessBoard.Length - 1 - i][j] = Integer.parseInt(chessBoardArray[i * 4 + j]);
                int chessId;
               
                chessId = Integer.parseInt(chessBoardArray[i * 6 + j]);
                customChessBoard[i][j] = chessId;
                
                chessBoard[i][j] = chessId;

                chessId = chessBoard[i][j];
                if (chessId == 0)  //看起來是紀錄board上空格的數量，尚不知有甚麼作用
                {
                    remainAllChessCount[0] += 1;
                }
//                else if(chessId != 3)
//                {
//                    if (chessId == 1 && chessId == 2)
//                    {
//                        liveChessCount[chessId - 1] += 1;
//                    }
//                    else if (chessId == 4 && chessId == 5)
//                    {
//                        liveChessCount[chessId - 2] += 1;
//                    }
//                }
            }
        }
        
        
        int ghostSum = 0;
        for (int i = 0, shiftCount = 0; i < remainAllChessCount.length; i++)
        {
            if (i != 0 && i != 3)
            {
                remainAllChessCount[i] = remainGhostCount[i - shiftCount];
                if(remainAllChessCount[i] < retainAllChessCount[i])   // 剩餘子數 少於 需保留子數
                {
                    return false;
                }
                ghostSum += remainAllChessCount[i];
            }
            else
            {
                shiftCount += 1;
            }
        }
        remainAllChessCount[3] = ghostSum; //總活棋個數
        return true;
    }

    void setgameStarted(String gameStarted)
    {
        this.gameStarted = gameStarted;
    }

    void setJudgeResult(String judgeResult)
    {
        if (this.judgeResult.equals(""))
        {
            this.judgeResult = judgeResult;
        }
    }

    void setGameStartTimeStamp(String gameStartTimeStamp)
    {
        this.gameStartTimeStamp = gameStartTimeStamp;
    }

    void setBoardEndingRecord(String boardEndingRecord)
    {
        this.boardEndingRecord = boardEndingRecord;
    }

//    void setplayer(String player1Color, String player2Color)
//    {
//        player[0] = player1Color;
//        player[1] = player2Color;
//    }
//    void setplayer() {
//    	player[0]="0";
//    	player[1]="1";
//    }
    void setUsedMilliSecond(int whoseTurn, long usedMilliSecond)
    {
        this.usedMilliSecond[whoseTurn] = usedMilliSecond;
    }

    void setGroupPlyCount(int whoseTurn, int groupPlyCount)
    {
        this.groupPlyCount[whoseTurn] = groupPlyCount;
    }

    void setMaxPlyCount(int MaxPlyCount)//無吃翻
    {
        this.MaxPlyCount = MaxPlyCount;
    }

    void setIsWaitingFirstPly(boolean isWaitingFirstPly)
    {
        this.isWaitingFirstPly = isWaitingFirstPly;
    }

    void setScore(String Score)
    {
        this.Score = Score;
    }

    void increaseStepCount()
    {
        stepCount += 1;
    }

    void increaseMaxPlyCount()
    {
        MaxPlyCount += 1;
    }

    void increaseGroupPlyCount(int whoseTurn)
    {
        groupPlyCount[whoseTurn] += 1;
    }

    void insertStepArray(String nextstep, int stepCount)
    {
        if (stepCount == stepArray.length)
        {
            String[] copyStepArray = new String[stepArray.length * 2];
            copyStepArray = Arrays.copyOf(stepArray, stepArray.length);
            stepArray = copyStepArray;
        }

        stepArray[stepCount] = nextstep;
    }
    
    void insertEatArray(String eatColor, int stepCount)
    {
        if (stepCount == eatArray.length)
        {
            String[] copyEatArray = new String[eatArray.length * 2];
            copyEatArray = Arrays.copyOf(eatArray, eatArray.length);
            eatArray = copyEatArray;
        }

        eatArray[stepCount] = eatColor;
    }

    void insertTimeArray(String timeStamp, int stepCount)
    {
        if (stepCount == timeArray.length)
        {
            String[] copyTimeArray = new String[timeArray.length * 2];
            copyTimeArray = Arrays.copyOf(timeArray, timeArray.length);
            timeArray = copyTimeArray;
        }

        timeArray[stepCount] = timeStamp;
    }

    void updateUsedMilliSecond(int whoseTurn, String preTimeStamp, String timeStamp)
    {
        usedMilliSecond[whoseTurn] += Long.parseLong(timeStamp) - Long.parseLong(preTimeStamp);
    }

//    void swapplayer()
//    {
//        String tempplayer = player[0];
//        player[0] = player[1];
//        player[1] = tempplayer;
//    }

//    void swapUsedMilliSecond()
//    {
//        long tempUsedMilliSecond = usedMilliSecond[0];
//        usedMilliSecond[0] = usedMilliSecond[1];
//        usedMilliSecond[1] = tempUsedMilliSecond;
//    }

//    void swapGoupPlyCount()
//    {
//        int tempGoupPlyCount = groupPlyCount[0];
//        groupPlyCount[0] = groupPlyCount[1];
//        groupPlyCount[1] = tempGoupPlyCount;
//    }
    
    int getnRandHashKey(String player1Name, String player2Name) {
    	int retHashCode = 0, hashSocket = 0, hashTime = 0;
        for (int i = 0; i < player1Name.length(); i++)
            retHashCode ^= (player1Name.charAt(i) << ((5 - (i % 6)) * 6));
        hashSocket ^= retHashCode;
        retHashCode = 0;
        for (int i = 0; i < player2Name.length(); i++)
            retHashCode ^= (player2Name.charAt(i) << ((5 - (i % 6)) * 6));
        hashSocket ^= retHashCode;
        Calendar calendar = Calendar.getInstance();
        String strTime = new SimpleDateFormat("yyyy").format(new Date()) + calendar.get(Calendar.MONTH) + calendar.get(Calendar.DATE) + 
        		calendar.get(Calendar.HOUR) + calendar.get(Calendar.MINUTE) + calendar.get(Calendar.SECOND) + calendar.get(Calendar.MILLISECOND);
        retHashCode = 0;
        for (int i = 0; i < strTime.length(); i++)
            retHashCode ^= (strTime.charAt(i) << ((5 - (i % 6)) * 6));
        hashTime = retHashCode;

        int nRandHashKey = hashSocket ^ hashTime;
        return nRandHashKey;
    }
    //計算隨機紅鬼位置
//    int[] computeIniRandRedloc(String player1Name, String player2Name) {
//    	int index = 0;
////        int[] p1IniGhostLoc = new int[] {25, 26, 27, 28, 31, 32, 33, 34};
////        int[] p2IniGhostLoc = new int[] {1, 2, 3, 4, 7, 8, 9, 10};
//        Set<Integer> P1selectedLoc = new LinkedHashSet<>();
//        Set<Integer> P2selectedLoc = new LinkedHashSet<>();
//        //P1紅鬼
//        int nRandHashKey = getnRandHashKey(player1Name, player2Name);
//        while (P1selectedLoc.size() < 4) {
//        	index = new Random(nRandHashKey).nextInt(8); //A~H:0~7
//        	P1selectedLoc.add(index);
//        	nRandHashKey = getnRandHashKey(player1Name, player2Name);
//        }
//        
//        //P2紅鬼
//        nRandHashKey = getnRandHashKey(player1Name, player2Name);
//        while (P2selectedLoc.size() < 4) {
//        	index = new Random(nRandHashKey).nextInt(8);
//        	P2selectedLoc.add(index);
//        	nRandHashKey = getnRandHashKey(player1Name, player2Name);
//        }
//        
//        int[] result = new int[8];
//        int i = 0;
//        for (int loc : P1selectedLoc) {
//        	result[i++] = loc;
//        }
//        for (int loc : P2selectedLoc) {
//        	result[i++] = loc;
//        }
//        
//        return result;
//    }

//    int computeRandChessId(String player1Name, String player2Name)//用來隨機選一個下一步
//    {
//        int retHashCode = 0, hashSocket = 0, hashTime = 0;
//        for (int i = 0; i < player1Name.length(); i++)
//            retHashCode ^= (player1Name.charAt(i) << ((5 - (i % 6)) * 6));
//        hashSocket ^= retHashCode;
//        retHashCode = 0;
//        for (int i = 0; i < player2Name.length(); i++)
//            retHashCode ^= (player2Name.charAt(i) << ((5 - (i % 6)) * 6));
//        hashSocket ^= retHashCode;
//        Calendar calendar = Calendar.getInstance();
//        String strTime = new SimpleDateFormat("yyyy").format(new Date()) + calendar.get(Calendar.MONTH) + calendar.get(Calendar.DATE) + 
//        		calendar.get(Calendar.HOUR) + calendar.get(Calendar.MINUTE) + calendar.get(Calendar.SECOND) + calendar.get(Calendar.MILLISECOND);
//        retHashCode = 0;
//        for (int i = 0; i < strTime.length(); i++)
//            retHashCode ^= (strTime.charAt(i) << ((5 - (i % 6)) * 6));
//        hashTime = retHashCode;
//
//        int nRandHashKey = hashSocket ^ hashTime;
//        int randChessId = 0, randNum = new Random(nRandHashKey).nextInt(remainAllChessCount[9]);
//        for (int i = 0; i < 6; i++)//隨便選到
//        {
//            if (i > 0 && i < 3 || i > 3 && i < 6)
//            {
//                randNum -= (remainAllChessCount[i] - retainAllChessCount[i]); // 排除保留指定棋子
//                if (randNum < 0)
//                {
//                    randChessId = RoomGSTJudgement.chessId[i];
//                    break;
//                }
//            }
//        }
//        return randChessId;
//
//    }

//    int openRetainChessId(int x, int y)//用于打开指定位置的自定义棋子，并返回其 ID
//    {
//        retainAllChessCount[customChessBoard[y][x]] -= 1;
//        return RoomGSTJudgement.chessId[customChessBoard[y][x]];
//    }

    void moveChessOnBoard(int[] x, int[] y, int pieceIndex)
    {
    	int dstLoc = y[1] * 6 + x[1];
        int[] twoChessId = { chessBoard[y[0]][x[0]], chessBoard[y[1]][x[1]] }; //twoChessId[0] = oldChessId, twoChessId[1] = newChessId
        if (twoChessId[1] != 0)
        {
            remainAllChessCount[0] += 1;
            remainAllChessCount[twoChessId[1]] -= 1;
            remainGhostCount[twoChessId[1] < 3 ? twoChessId[1] - 1 : twoChessId[1] - 2] -= 1;//
            
            for (int i = 0; i < 16; i++) {
            	if (GhostCodeLocation[i] == dstLoc) {
            		GhostCodeLocation[i] = 36; //被吃的棋子的位置
            	}
            }
        }
        chessBoard[y[0]][x[0]] = 0;
        chessBoard[y[1]][x[1]] = twoChessId[0];
        GhostCodeLocation[pieceIndex] = dstLoc;
    }
    
    void chessEscapeOnBoard(int x, int y) {
    	int escapeChessId = chessBoard[y][x];
    	escapeChess = escapeChessId;
    	remainAllChessCount[0] += 1;
//    	chessBoard[y][x] = 0;
    }

//    void openChessOnBoard(int x, int y, int newChessId)//在棋盘上指定位置打开一个新的棋子
//    {
//        int[] twoChessId = { chessBoard[y][x], newChessId }; //twoChessId[0] = oldChessId, twoChessId[1] = newChessId
//        remainAllChessCount[8] -= 1;//
//        remainAllChessCount[newChessId] -= 1;
//        chessBoard[y][x] = twoChessId[1];
//    }

    void shiftTimeList(long timeDiff)
    {
        long newTimeStamp = 0;
        for (int i = 0; i <= stepCount; i++) //要使用 "<="
        {
            newTimeStamp = Long.parseLong(timeArray[i]) + timeDiff;
            timeArray[i] = newTimeStamp + "";
        }
    }

    void showChessBoard()
    {
        for (int i = 0; i < chessBoard.length; i++)
        {
            String rowOfChessBoard = "";
            for (int j = 0; j < chessBoard[i].length; j++)
            {
                rowOfChessBoard += RoomGSTJudgement.chessName[chessBoard[i][j]] + ",   ";
            }
            RoomGST.DEBUG(rowOfChessBoard);
        }
    }
    
    Boolean setCustomRedGhost(String redGhost, int player) { //player = 0 or 1
    	if (redGhost.length() != 4) return false;
    	
    	int colorOffset = 0, indexOffset = 0;
    	if (player == 1) {
    		colorOffset = 3;
    		indexOffset = 8;
    	}
    	int index, x, y;
		for(int i = 0; i < 4; i++) {
			index = (int)redGhost.charAt(i) - (int)('A');
			if(index > 7) return false;
			GhostCodeColor[index + indexOffset] = 1;
		}
		for(int i = 0; i < 8; i++) {
			index = i + indexOffset;
			x = GhostCodeLocation[index] % 6;
			y = GhostCodeLocation[index] / 6;
			chessBoard[y][x] = GhostCodeColor[index] + colorOffset;
		}
		return true;
    }
    
    String getStrChessBoard()
    {
        String strChessBoard = "";
        for (int i = 0; i < chessBoard.length; i++)
        {
            for (int j = 0; j < chessBoard[i].length; j++)
            {
                strChessBoard += chessBoard[i][j] + ",";
            }
        }
        return RoomGST.TrimEnd(strChessBoard, ',');
    }

    String getStrremainAllChessCount()
    {
        String strremainAllChessCount = "";
        for (int i = 0; i < remainAllChessCount.length; i++)
        {
            if (i != 0 && i != 3)//
            {
                strremainAllChessCount += String.valueOf(remainAllChessCount[i]) + ",";
            }
        }
        return RoomGST.TrimEnd(strremainAllChessCount, ',');
    }

    int[][] getChessBoard()
    {
        // 為了速度，其實可以直接使用一維陣列，會快很多
        return chessBoard; //需要用Array.Copy()，但為了節省速度，所以偷懶不用
    }

    int getAllremainAllChessCount()
    {
        return remainAllChessCount[3];
    }

    int[] getremainAllChessCount()
    {
        return remainAllChessCount;  //需要用Array.Copy()，但為了節省速度，所以偷懶不用
    }

    int[] getremainGhostCount()
    {
        return remainGhostCount;
    }

    int getStepCount()
    {
        return stepCount;
    }

    String getgameStarted()
    {
        return gameStarted;
    }

    String getJudgeResult()
    {
        return judgeResult;
    }

    String[] getStepArray()
    {
        return stepArray; //需要用Array.Copy()，但為了節省速度，所以偷懶不用
    }

    String getStepList()
    {
        String stepList = "";
        stepList += stepArray[1];
        for (int i = 2; i <= stepCount; i++)
        {
            stepList += " " + stepArray[i];
        }
        return stepList;
    }
    
    // 用於localserver undo
    String getStepList(int movelength)
    {
        String stepList = "";
        stepList += stepArray[1];
        for (int i = 2; i <= movelength; i++)
        {
            stepList += "," + stepArray[i];
        }
        return stepList;
    }

    String[] getTimeArray()
    {
        return timeArray; //需要用Array.Copy()，但為了節省速度，所以偷懶不用
    }

    String getTimeList()
    {
        String timeList = "";
        timeList += timeArray[0];
        for (int i = 1; i <= stepCount; i++)
        {
            timeList += "," + timeArray[i];
        }
        return timeList;
    }
    
    // 用於localserver undo
    String getTimeList(int timelength)
    {
        String timeList = "";
        timeList += timeArray[0];
        for (int i = 1; i <= timelength; i++)
        {
            timeList += "," + timeArray[i];
        }
        return timeList;
    }

    String getTimeStamp(int stepCount)
    {
        return timeArray[stepCount];
    }
    
    String getEatList()
    {
        String eatList = "";
        eatList += eatArray[1];
        for (int i = 2; i <= stepCount; i++)
        {
        	eatList += "," + eatArray[i];
        }
        return eatList;
    }

    String getBoardEndingRecord()
    {
        return boardEndingRecord;
    }

    String getGameStartTimeStamp()
    {
        return gameStartTimeStamp;
    }

    String getplayer(int whoseTurn)
    {
        return player[whoseTurn];
    }

    long getUsedMilliSecond(int whoseTurn)
    {
        return usedMilliSecond[whoseTurn];
    }

    int getGroupPlyCount(int whoseTurn)
    {
        return groupPlyCount[whoseTurn];
    }

    int getMaxPlyCount()
    {
        return MaxPlyCount;
    }

    boolean getIsWaitingFirstPly()
    {
        return isWaitingFirstPly;
    }
    
    String getScore()
    {
        return Score;
    }

    int getCustoBoardChessId(int x , int y)
    {
        return customChessBoard[y][x];
    }
    
    int getEscapeChess() {
    	return escapeChess;
    }
    
    int[] getGhostCodeLocation() {
    	return GhostCodeLocation;
    }
    
    int getChostLocation(int indexOfCode) {
    	return GhostCodeLocation[indexOfCode];
    }
    
    void setGhostCodeLocation(int[] ghostCodeLoc) {
    	GhostCodeLocation = ghostCodeLoc;
    }
    
    int[] getGhostCodeColor() {
    	return GhostCodeColor;
    }
    
    void setGhostCodeColor(int[] ghostCodeColor) {
    	GhostCodeColor = ghostCodeColor;
    }
}
