package com.RoomDLL;

import com.PlayerInfoDLL.PlayerInfo;

public abstract class GameRoom {
    private Thread roomThread;

    private int roomId;
    private RoomState.roomState roomState;
    public final static long firstPly_LimitTime = 300000; //第一手限制時間(毫秒)

    public GameRoom(int roomId, RoomState.roomState roomState)
    {
        this.roomId = roomId;
        this.roomState = roomState;

        roomThread = new Thread(() -> {});
    }

    public boolean baseRoomSetBoard(String boardInfo, StringBuilder setBoardResult)
    {
        if (roomState == RoomState.roomState.Setting && roomSetBoard(boardInfo, setBoardResult))
        {
            roomState = RoomState.roomState.Waiting;
            return true;
        }
        else
        {
            return false;
        }
    }

    public boolean baseAddPlayer(PlayerInfo playerInfo, String context, StringBuilder addPlayerResult)
    {
        return addPlayer(playerInfo, context, addPlayerResult);
    }

    public void roomThreadNotify(){
        roomThread.start();
    }

    protected int getRoomId()
    {
        return roomId;
    }

    public RoomState.roomState getRoomState()
    {
        return roomState;
    }

    protected boolean gameReady()
    {
        boolean isSuccess = false;
        if (roomState == RoomState.roomState.Waiting)
        {
            roomState = RoomState.roomState.Ready;
            baseRoomMain();
            // ThreadPool.QueueUserWorkItem(baseRoomMain);
            isSuccess = true;
        }
        return isSuccess;
    }

    protected void closeRoom()
    {
        GameRoom.display(String.format("roomId = %d, roomState = %s, 房間正在關閉", roomId, roomState));
        roomState = RoomState.roomState.Empty;
        GameRoom.display(String.format("roomId = %d, roomState = %s, 房間已關閉等待 GC 回收", roomId, roomState));
    }

    private void baseRoomMain()
    {
        roomState = RoomState.roomState.Started;
        roomThread = new Thread(new Runnable() {
            @Override
            public void run() {
                roomMain();
            }
        });
        // gameStartManualResetEvent.WaitOne();
        // if (RoomState.changeRoomStateReadyToStarted(roomId, ref roomState))
        // {
        //     Thread roomMainThread = new Thread(new ThreadStart(roomMain));
        //     roomMainThread.Start();
        // }
        // gameStartManualResetEvent.Reset();
    }

    private static void display(String message)
    {
        System.out.println(message);
    }

    abstract public String getRoomInfo();

    abstract public String getGameType();

    abstract protected boolean roomSetBoard(String boardInfo, StringBuilder setBoardResult);

    abstract protected boolean addPlayer(PlayerInfo playerInfo, String context, StringBuilder addPlayerResult);

    abstract protected void roomMain();
}