package gst;

import client.Action;

/**
 * 
 * 管理所有的指令代號，並記錄所有指令代號的名稱，方便 Debug 時顯示。
 * 
 * @author ldsld449
 * @see client.Action
 *
 */

public class GST_Action extends Action{
	
	final static short InitialSetting = 22;
	final static short SetRed = 23;
	final static short InitialBoard = 24;
	final static short GameStart = 25;
	final static short Move = 26;
	final static short GameResult = 27;
	final static short GetBoardEndingRecord = 28;
	final static short GameFinish = 29;
	final static short Resign = 30;
	final static short DrawOffer = 31;
	final static short Abort = 32;
	final static short Undo = 33;
	
	/**
	 * 各個指令代碼的名稱，以各指令的代號來決定 Array 位置。
	 * 請注意：因為此為遊戲指令，依照規定由 21 開始編起，因此 Array 第一格為編號 20 的指令名稱，依此類推。
	 */
	public final static String[] GST_ActionName = {"",
			"", "InitialSetting", "SetRed", "InitialBoard" ,"GameStart", "Move",
			"GameResult", "GetBoardEndingRecord", "GameFinish", "Resign", "DrawOffer",
			"Abort", "Undo"
	};
	
}
