package gst;

import javax.swing.JDialog;
import net.miginfocom.swing.MigLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import java.awt.Font;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

import org.apache.commons.lang3.math.NumberUtils;

import javax.swing.JButton;

/**
 * 設定棋子分數的頁面。
 * @author ldslds449
 * 
 */

public class WDLBScore extends JDialog {
	
	public JTextField Win_Field;
	public JTextField Draw_Field;
	public JTextField Lose_Field;
	
	private String[] Piece_Code = {"K", "G", "M", "R", "N", "C", "P"};
	public ArrayList<JTextField> Piece_Score_Fields = new ArrayList<JTextField>();
	public JTextField Bonus_Limit_Field;
	public JTextField Bonus_Field;
	
	
	public WDLBScore(JLabel label) {
		setTitle("Score Setting");
		setSize(550, 350);
		setModal(true);
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		
		getContentPane().setLayout(new MigLayout("", "[140,grow][140][140][140,grow][140][140,grow][140][140][140]", "[35,grow][35,grow][35,grow][35,grow][35,grow][35,grow][35,grow]"));
		
		JLabel Win = new JLabel("Win: ");
		Win.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Win, "cell 0 0,alignx center");
		
		Win_Field = new JTextField();
		Win_Field.setHorizontalAlignment(SwingConstants.CENTER);
		Win_Field.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Win_Field, "cell 1 0 2 1,grow");
		
		JLabel Draw = new JLabel("Draw: ");
		Draw.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Draw, "cell 3 0,alignx center,growy");
		
		Draw_Field = new JTextField();
		Draw_Field.setHorizontalAlignment(SwingConstants.CENTER);
		Draw_Field.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Draw_Field, "cell 4 0 2 1,grow");
		
		JLabel Lose = new JLabel("Lose: ");
		Lose.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Lose, "cell 6 0,alignx center,growy");
		
		Lose_Field = new JTextField();
		Lose_Field.setHorizontalAlignment(SwingConstants.CENTER);
		Lose_Field.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Lose_Field, "cell 7 0 2 1,grow");
		
		JLabel Red = new JLabel("Red: ");
		Red.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Red, "cell 0 2,alignx right,growy");
		
		JLabel Black = new JLabel("Black: ");
		Black.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Black, "cell 0 3,alignx right,growy");
		
		JLabel Bonus = new JLabel("棋子分數比對方多");
		Bonus.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Bonus, "cell 0 4 3 1,alignx center,growy");
		
		Bonus_Limit_Field = new JTextField();
		Bonus_Limit_Field.setHorizontalAlignment(SwingConstants.CENTER);
		Bonus_Limit_Field.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Bonus_Limit_Field, "cell 3 4,grow");
		Bonus_Limit_Field.setColumns(10);
		
		JLabel Get = new JLabel("得");
		Get.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Get, "cell 4 4,alignx center,growy");
		
		Bonus_Field = new JTextField();
		Bonus_Field.setHorizontalAlignment(SwingConstants.CENTER);
		Bonus_Field.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Bonus_Field, "cell 5 4,grow");
		Bonus_Field.setColumns(10);
		
		JLabel Score = new JLabel("分");
		Score.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Score, "cell 6 4,alignx center,growy");
		
		JLabel Bonus_Explain = new JLabel("(如果棋子分數比對方多，但不到設定的值，則依比例給分)");
		Bonus_Explain.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(Bonus_Explain, "cell 0 5 9 1,alignx center,growy");
		
		JButton OK_Button = new JButton("OK");
		OK_Button.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
		getContentPane().add(OK_Button, "cell 8 6,grow");
		OK_Button.addActionListener((e) -> WDLBScore.this.dispatchEvent(new WindowEvent(WDLBScore.this, WindowEvent.WINDOW_CLOSING)));
		
		// Label
		for(int i = 0; i < Piece_Code.length; ++i){
			JLabel tmp = new JLabel(Piece_Code[i]);
			tmp.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
			getContentPane().add(tmp, "cell " + String.valueOf(1+i) + " 1,alignx center,growy");
		}
		// TextField
		for(int i = 0; i < 2; ++i){
			for(int j = 0; j < Piece_Code.length; ++j){
				JTextField tmp = new JTextField();
				tmp.setFont(new Font("微軟正黑體", Font.PLAIN, 17));
				tmp.setHorizontalAlignment(SwingConstants.CENTER);
				getContentPane().add(tmp, 
						"cell " + String.valueOf(1+j) + " " + String.valueOf(2+i) + ",grow");
				Piece_Score_Fields.add(tmp);
			}
		}
		
		addWindowListener(new WindowAdapter() {
		    @Override
		    public void windowClosing(WindowEvent evt) {
		    	// check
		    	if(!NumberUtils.isCreatable(Win_Field.getText())){
		    		JOptionPane.showMessageDialog(WDLBScore.this, "Win Score is not valid");
		    		return;
		    	}
		    	if(!NumberUtils.isCreatable(Draw_Field.getText())){
			    		JOptionPane.showMessageDialog(WDLBScore.this, "Draw Score is not valid");
			    		return;
		    	}
		    	if(!NumberUtils.isCreatable(Lose_Field.getText())){
			    		JOptionPane.showMessageDialog(WDLBScore.this, "Lose Score is not valid");
			    		return;
		    	}
		    	if(!NumberUtils.isCreatable(Bonus_Field.getText())){
			    		JOptionPane.showMessageDialog(WDLBScore.this, "Bonus Score is not valid");
			    		return;
		    	}
		    	if(!NumberUtils.isCreatable(Bonus_Limit_Field.getText())){
			    		JOptionPane.showMessageDialog(WDLBScore.this, "Bonus Limit Score is not valid");
			    		return;
		    	}
		    	
		    	
		    	for(int i = 0; i < Piece_Score_Fields.size(); ++i){
		    		if(!NumberUtils.isCreatable(Piece_Score_Fields.get(i).getText())){
		    			String piece;
		    			if(i < Piece_Code.length){
		    				piece = Piece_Code[i];
		    			}else{
		    				piece = Piece_Code[i - Piece_Code.length].toLowerCase();
		    			}
		    			JOptionPane.showMessageDialog(WDLBScore.this, 
		    					String.format("Field %s Score is not valid", piece));
		    			return;
		    		}
		    	}
		    	
		    	// pass
		    	label.setText(String.format("%.2f / %.2f / %.2f", 
			    		Double.parseDouble(Win_Field.getText()),
			    		Double.parseDouble(Draw_Field.getText()),
			    		Double.parseDouble(Lose_Field.getText())));
		    	
		    	WDLBScore.this.setVisible(false);
		    }
		});
	}
}
