function BaseBoard(row, col, PiecesNum, Players, name, mode, scale = 1) {
  if (name == null) return;
  this.name = name;
  this.piece_row = parseInt(row);//
  this.piece_col = parseInt(col);
  this.blank_row = parseInt(row);
  this.blank_col = parseInt(col);

  this.boundary_top = 0;
  this.boundary_left = 0;

  this.blank_size = 40 * scale;
  this.border_width = 3 * scale;
  this.piece_font_size = 30 * scale;
  this.piece_bound_top = 40;
  this.piece_bound_left = 40;
  this.bound_font_size = 20 * scale;
  this.die_blank_size = 25 * scale;
  this.die_piece_font_size = 18 * scale;
  this.movelist_font_size = 12 * scale;

  // language
  this.lang_select = this.new_div("div_lang_select");
  this.lang_select.innerHTML = `
    <p class="i18n" i18next_key="switch">${i18next.t('switch')}</p>
    <select id="language-selector">
        <option value="en">English</option>
        <option value="zh">中文</option>
        <option value="jp">にほんご</option>
    </select>
  `;
  // 從本地儲存中讀取已儲存的語言設定
  const savedLanguage = sessionStorage.getItem('selectedLanguage') || 'en';

  // 設置選單的預設值
  document.getElementById('language-selector').value = savedLanguage;
  bindLanguageSelector();

  //checkbox的位置
  this.checkbox_top = 120 * scale;

  //checkbox的div
  this.checkbox = this.new_div("div_checkBox");

  //pieceCount的位置
  // this.pieceCount_top = 400 * scale;
  // this.pieceCount_left = 200 * scale;

  // 創建一個元素來顯示棋子顏色數量
  // this.pieceCount = this.new_div("div_pieceCount");

  this.div_board = this.new_div("div_board_" + name);
  this.div_piece = this.new_div("div_piece_" + name);

  this.div_movelist = this.new_div("div_movelist_" + name);

  this.BoardSize = parseInt(row);
  this.PiecesNum = parseInt(PiecesNum);
  this.Players = parseInt(Players);

  // GST: P1 & P2
  this.div_P1_died = this.new_div("div_P1_died" + name);
  this.div_P2_died = this.new_div("div_P2_died" + name);



  this.PCE_CODE = ["A", "B", "C", "D", "E", "F", "G", "H", "a", "b", "c", "d", "e", "f", "g", "h"];
  

  // GST: PCE_TYPE:
  this.PCE_TYPE = {
    "P1": { className: "GST_piece_P1" },
    "P1_R": { className: "GST_piece_P1_R" },
    "P1_B": { className: "GST_piece_P1_B" },
    "P2": { className: "GST_piece_P2" },
    "P2_R": { className: "GST_piece_P2_R" },
    "P2_B": { className: "GST_piece_P2_B" }
  };


  this.div_endgame_movelist = this.new_div("div_endgame_movelist_" + name);
  this.div_path = null;

  this.LANG_EN = 0;
  this.LANG_CH = 1;
  this.LANG = this.LANG_CH;

  this.STR_NUM = ["０", "１", "２", "３", "４", "５", "６", "７", "８", "９"];
  this.EN_NUM = ["", "ａ", "ｂ", "ｃ", "ｄ"];
  this.CH_NUM = ["", "一", "二", "三", "四", "五", "六", "七", "八", "九"];

  this.after_blank = null;
  this.select_blanks = new Array();

  /*test*/
  this.ini = null;
  this.firstload = true;
  this.alllist = new Array();
  this.isaddmovelist = true;
  this.isstopboard = false;
  this.randNum = -1;
  this.his_create_name = false;
  this.his_step = -1;  // keydown 
  this.metaChar = false;  // keydown
  this.exampleKey = 16; // keydown
  this.split_str = "\r\n"; // windows->\r\n, linux->\n
  this.os_type = "\r\n";  // windows->\r\n, linux->\n
  this.turn = 0; // 1 my turn 0 opp
  this.board_data = ""; // board information
  this.info_row = new Array();  // user information row 
  this.info_error_row = new Array();  // user error information row
  this.info = new Array();  // user information
  this.info_error = new Array();  //user error information
  this.acttime = new Array(); // board history user time
  this.actlist = new Array(); // board history user move
  this.genlist = new Array(); // GST: board history genmove 因為格式不同
  this.eatlist = new Array(); // used in Save()
  this.red_pce_id = new Array(); //used for hide/show pce color 
  this.tmp = null;
  this.player = 0; // step count
  this.player_name = new Array(); // 0: players 1: player1 2: player2
  this.firstcolor = -1; // GST: server端的firstcolor 暫代表檢查棋局是否開始 0:還沒 1:已開始
  this.socket = null;
  this.clr = -1; // GST: 0: red, 1: blue
  this.turnclr = 0;// 0: red 1: blue
  this.playmode = 0;// 0: AI 1: Human
  this.mode = mode; // 1: index.html, 0: history, 2: abort 3: observe history 4: history.html
  this.record_genmove = ""; // if isstopboard == true && recv gnemove, record genmvoe
  this.highlight = false;  // 歷史紀錄選中效果
  this.gameResult = "";
  // this.firstcolor = -1;// 0: red, 1: blue
  this.his_openf = "";
  //this.step = -1;


  //棋子數量
  this.PCE_QUA = new Map([
    ["R", 4],
    ["B", 4],
    ["r", 4],
    ["b", 4]
  ])
  //死棋數量
  this.PCE_DIE = new Map([
    ["R", 0],
    ["B", 0],
    ["r", 0],
    ["b", 0]
  ])


}

BaseBoard.prototype = {
  new_div: function (id) {
    document.write("<div id=\"" + id + "\"></div>");
    return document.getElementById(id);
  },
  new_div_shape: function (className, top, left, height, width, font_size, t_index, css_text = "") {
    var div = document.createElement("div");
    div.className = className;
    if (t_index != null) { div.id = t_index; }
    //if(t_index != 0){div.id = t_index;}
    div.style.cssText = "width:" + width + "px;";
    div.style.cssText += "height:" + height + "px;";
    div.style.cssText += "top:" + top + "px;";
    div.style.cssText += "left:" + left + "px;";
    div.style.cssText += "line-height:" + height + "px;";
    div.style.cssText += "font-size:" + font_size + "px;";
    div.style.cssText += css_text;
    return div;
  },
  new_div_shape_line_height: function (className, top, left, height, width, font_size, line_height) {
    var div = document.createElement("div");
    div.className = className;
    div.style.cssText = "width:" + width + "px";
    div.style.cssText += "height:" + height + "px";
    div.style.cssText += "top:" + top + "px";
    div.style.cssText += "left:" + left + "px";
    div.style.cssText += "line-height:" + line_height + "px;";
    div.style.cssText += "font-size:" + font_size + "px;";
    return div;
  },
  new_board_shape: function (className, top, col) {
    return this.new_div_shape(className, row, col, this.blank_size, this.piece_font_size);
  },
  new_board_blank: function (row, col, text) {
    var top = row * (this.blank_size + this.border_width);
    var left = col * (this.blank_size + this.border_width);
    var s = null;
    s = col + "_" + row; // x_y
    var obj = this.new_div_shape("blank", top, left, this.blank_size, this.blank_size, this.piece_font_size, s);
    /* mouse click */
    obj.onclick = this.shape_mouse_click;
    return obj;
  },

  new_board_escape: function (text, t, l) {
    let top = t * (this.blank_size + this.border_width);
    let left = l * (this.blank_size + this.border_width);
    let s = null;
    s = "8_8_" + text; // x_y
    let obj = this.new_div_shape("escape", top, left, this.blank_size, this.blank_size, this.piece_font_size, s);
    /* mouse click */
    obj.onclick = this.shape_mouse_click;
    return obj;
  },

  new_board_piece: function (row, col, className, code) {

    /* test */
    var div = this.new_div_shape("GST_piece", 0, 0, this.blank_size, this.blank_size, this.piece_font_size);
    var piece_str = this.new_div_shape(className, 0, 0, this.blank_size, this.blank_size, this.piece_font_size - 7);

    piece_str.id = code;

    div.append(piece_str);
    var piece_blank = null;
    div.onclick = this.piece_click;
    piece_blank = document.getElementById(col + "_" + row);
    piece_blank.appendChild(div);
    return piece_blank;

  },
  new_bound: function (row, col, text) {
    var top = row * (this.blank_size + this.border_width);
    var left = col * (this.blank_size + this.border_width);
    var div = this.new_div_shape("boundary", top, left, this.blank_size, this.blank_size, this.bound_font_size);
    div.append(text);
    return div;
  },
  new_die_piece: function (row, col, className, text) {
    var top = row * (this.die_blank_size + this.border_width);
    var left = col * (this.die_blank_size + this.border_width);
    var div = this.new_div_shape(className, top, left, this.die_blank_size, this.die_blank_size, this.die_piece_font_size);

    //DEBUG(className);
    div.id = "die_" + text;
    //DEBUG(val, this.PCE_QUA);
    return div;
  },

  new_movelist_title: function (text) {
    var height = this.movelist_font_size * 1.5;
    var width = (text.length + 2) * this.movelist_font_size;
    var left = 1 * (this.blank_size + this.border_width);
    var div = this.new_div_shape("label", 0, left, height, width, this.movelist_font_size);
    div.className += ' i18n';
    div.setAttribute('i18next_key', text);
    div.append(i18next.t(text));
    return div;
  },

  new_movelist: function (row, col) {
    var height = row * (this.blank_size + this.border_width);
    var width = col * (this.blank_size + this.border_width) * 1.2;;
    var top = this.movelist_font_size * 2;
    return this.new_div_shape("path", top, 0, height, width, height);
  },
  new_movelist_move: function (row, col, type, text) {
    var height = this.movelist_font_size * 1.8;
    var width = (text.length + 1) * this.movelist_font_size;
    var top = row * (this.movelist_font_size) * 2;
    var left = col * (this.blank_size + this.border_width) + this.movelist_font_size * 2 + 3;
    var div_num = this.new_div_shape_line_height("move_num", top, 0, height, this.movelist_font_size * 2, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div_move = this.new_div_shape_line_height(type, top, left, height, width, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div = document.createElement("div");

    div.setAttribute("top", top);
    div_move.append(text);
    div_num.append((row + 1) + ".");
    div.append(div_num);
    div.append(div_move);
    if (this.mode != 1) {
      div.onclick = function () { board.history_move(parseInt(top / 24)) };
    }
    return div;
  },
  new_observation_movelist_move: function (round, player, type, text) {
    DEBUG(
      "new_observation_movelist_move: " +
      " " +
      round + // 第幾步，排版用
      " " +
      player + // 玩家，0/1
      " " +
      type + //move或time，排版用
      " " +
      text // open/enter裡 add_path(str)寫好的東西
    );
    var height = this.movelist_font_size * 1.5;
    var width = 6 * this.movelist_font_size; //
    var top = round * this.movelist_font_size * 2;

    if (type != "time1" && type != "time2") {
      var left =
        0 * (this.blank_size + this.border_width) +
        this.movelist_font_size * 2 +
        3;
      var div_num = this.new_div_shape_line_height(
        "move_num",
        top,
        0,
        height,
        this.movelist_font_size * 2,
        this.movelist_font_size,
        this.movelist_font_size * 1.1
      );
      var div_move = this.new_div_shape_line_height(
        type,
        top,
        left,
        height,
        width,
        this.movelist_font_size,
        this.movelist_font_size * 1.3
      );
    } else {
      var left = 2 * (this.blank_size + this.border_width) + this.movelist_font_size * 2 - 3;
      var div_move = this.new_div_shape_line_height(
        type,
        top,
        left,
        height,
        8 * this.movelist_font_size,
        this.movelist_font_size,
        this.movelist_font_size * 1.3
      );
    }

    var div = document.createElement("div");

    div.setAttribute("top", top);
    div_move.append(text);
    if (type != "time1" && type != "time2") {
      div_num.append((round + 1) + ".");
      div.append(div_num);
    }
    div.onclick = function () { board.history_move(parseInt(top / 24)) };
    div.append(div_move);
    return div;
  },
  new_endgame_movelist_move: function (row, col, type, text, end_score, end_type) {
    let _this = this;
    var left = function (col) { return col * (_this.blank_size + _this.border_width) + _this.movelist_font_size * 2 + 3; }
    var height = this.movelist_font_size * 1.8;
    var width = (text.length + 1) * this.movelist_font_size;
    var top = row * (this.movelist_font_size) * 2;
    var div_num = this.new_div_shape_line_height("move_num", top, 0, height, this.movelist_font_size * 2, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div_move = this.new_div_shape_line_height(type, top, left(col), height, width, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div_scr = this.new_div_shape_line_height("end_score", top, left(col + 2), height, this.movelist_font_size * 2, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div_type = this.new_div_shape_line_height("end_type", top, left(col + 2.6), height, this.movelist_font_size * 2, this.movelist_font_size, this.movelist_font_size * 1.3);
    var div = document.createElement("div");
    div.setAttribute("top", top);
    div_move.append(text);
    div_num.append(row + ".");
    div_scr.append(end_score);
    div_type.append(end_type);
    div.append(div_num);
    div.append(div_move);
    div.append(div_scr);
    div.append(div_type);
    return div;
  },
  new_right_arrow: function (row, col, height, width) {
    var top = row * (this.blank_size + this.border_width);
    var left = col * (this.blank_size + this.border_width);
    return this.new_div_shape("right_arrow", top, left, height, width, height);
  },
  new_left_arrow: function (row, col, height, width) {
    var top = row * (this.blank_size + this.border_width);
    var left = col * (this.blank_size + this.border_width);
    return this.new_div_shape("left_arrow", top, left, height, width, height);
  },
  new_number_move: function (row, col, height, width, text) {
    var top = row * (this.blank_size + this.border_width);
    var left = col * (this.blank_size + this.border_width);
    var div = this.new_div_shape("label", top, left, height, width, this.movelist_font_size);
    div.append(text);
    return div;
  },
  toClassName: function (side) {
    return this.PCE_TYPE[side].className;
  },
  set_board: function (board) { }
}

BaseBoard.prototype.init = function () {
  console.log("init " + this.name + " mode " + this.mode);
  var link = document.createElement('link');
  link.href = "chess.css";
  link.rel = "stylesheet";
  var tagN = document.getElementsByTagName("link");
  if (tagN.length == 0) {
    document.getElementsByTagName('head')[0].append(link);
  }

  var lang = document.createElement('script');
  lang.innerHTML = "document.getElementById('language-selector').addEventListener('change', function () {i18next.changeLanguage(this.value);});";
  var tagN = document.getElementsByTagName("script");
  if (tagN.length == 0) {
    document.getElementsByTagName('head')[0].append(lang);
  }



  this.screen_init();
  this.board_init();
  this.chess_board_init();
  //
  this.piece_init();
  this.died_piece_init();
  //
  this.checkbox_init();
  this.player_name_init();
  // if(this.mode != 4){
  //   this.player_name_init();
  // }
  this.div_movelist.append(this.new_movelist_title("step"));//走步語言設定
  this.div_path = this.new_movelist(this.piece_row, 4.5);

  this.div_movelist.append(this.div_path);

  document.body.onkeydown = this.keyEvent;
  document.body.onkeyup = this.metaKeyUp;

};
// 歷史紀錄初始化(註解是暗棋的程式)
function his_init(index) {

  if (board.mode == 1 && board.isstopboard == false) { return; }
  if (document.getElementById("set_mode") != null &&
    document.getElementById("set_mode").checked == false) {
    return;
  }
  DEBUG("his_init");
  // 保存當前棋盤狀態
  let record_genmove = board.record_genmove;
  let turn = board.turn;
  let stop_flag = board.isstopboard;
  let turnclr = board.turnclr;
  let buf = board.actlist;
  let buf2 = board.genlist;
  let buf3 = board.red_pce_id;
  let mode = board.mode;
  let ply = board.player; // 步數
  let players = board.Players;
  var name = board.player_name; // 玩家1或2
  var sock = board.socket;

  let bs = board.BoardSize;
  let pn = board.PiecesNum;
  let ini = board.ini;
  let highlight = board.highlight;
  let result = board.gameResult;

  // history.html
  let mui = document.getElementById("mui_sw");
  let mui1 = document.getElementById("mui_sw1");
  let div_endgame = document.getElementById("div_endgame_movelist_GST");
  let openf = board.his_openf;
  let info_show = board.info;
  let infoerr_show = board.info_error;
  let info_r = board.info_row;
  let infoerr_r = board.info_error_row;
  let data = board.board_data;
  let tbuf = board.acttime;
  let hide1= document.getElementById("hideP1").checked;
  let hide2= document.getElementById("hideP2").checked;

  let f = true; let f1 = true;

  if (mui != null) {
    f = mui.checked;
    f1 = mui1.checked;
  }

  DEBUG(mui, mui1, f, f1);

  /*
  let initBoard = board.initBoard;
  let initRemainDarkChess = board.initRemainDarkChess;
  

  let als = board.alllist;
  let firld = board.firstload;
  let firstcolor = board.firstcolor;
  */

  if (board.mode == 0 || board.mode == 3) {
    DEBUG("|| HISTORY SAVE\n"
      + "|| board.record_genmove: " + board.record_genmove + "\n"
      + "|| board.turn: " + board.turn + "\n"
      + "|| board.isstopboard: " + board.isstopboard + "\n"
      + "|| board.turnclr: " + board.turnclr + "\n"
      + "|| board.actlist: " + board.actlist + "\n"
      + "|| board.genlist: " + board.genlist + "\n"
      + "|| board.red_pce_id: " + board.red_pce_id + "\n"
      + "|| board.mode: " + board.mode + "\n"

      + "|| board.player: " + board.player + "\n"
      + "|| board.Players: " + board.Players + "\n"
      + "|| board.player_name: " + board.player_name + "\n"
      + "|| board.BoardSize: " + board.BoardSize + "\n"
      + "|| board.PiecesNum: " + board.PiecesNum + "\n"
      + "|| board.ini: " + board.ini + "\n"
      + "|| board.highlight: " + board.highlight + "\n"
      + "|| board.gameResult: " + board.gameResult + "\n"

      + "|| board.his_step: " + board.his_step + "\n"
    );
  } else if (board.mode == 4) {
    DEBUG("|| HISTORY.HTML SAVE\n"
      + "|| board.actlist: " + board.actlist + "\n"
      + "|| board.genlist: " + board.genlist + "\n"
      + "|| board.red_pce_id: " + board.red_pce_id + "\n"
      + "|| board.mode: " + board.mode + "\n"

      + "|| board.player: " + board.player + "\n"
      + "|| board.BoardSize: " + board.BoardSize + "\n"
      + "|| board.PiecesNum: " + board.PiecesNum + "\n"
      + "|| board.ini: " + board.ini + "\n"
      + "|| board.highlight: " + board.highlight + "\n"

      + "|| board.his_openf: " + board.his_openf + "\n"
      + "|| board.board_data: " + board.board_data + "\n"

      + "|| board.his_step: " + board.his_step + "\n"
    );
  }


  // 清空頁面並建立新的棋盤
  board = null;
  document.body.innerHTML = "";
  document.body.setAttribute("overflow-x", "hidden");
  document.body.setAttribute("overflow-y", "hidden");
  board = new GSTBoard(bs, pn, players, mode);

  board.record_genmove = record_genmove;
  board.turn = turn;
  board.isstopboard = stop_flag;
  board.turnclr = turnclr;
  board.actlist = buf;
  board.genlist = buf2;
  board.red_pce_id = buf3;
  board.mode = mode;
  board.player = ply;
  board.Players = players;
  board.player_name = name;
  board.socket = sock;

  board.BoardSize = bs;
  board.PiecesNum = pn;
  board.ini = ini;
  board.highlight = highlight;
  board.gameResult =  result;

  board.his_step = index;

  console.log("initboard = " + board.ini);
  Recv("players " + board.player_name[1] + " " + board.player_name[2]);
  Recv("initboard " + board.ini);

  //history.html
  board.board_data = data;
  board.info = info_show;
  board.info_error = infoerr_show;
  board.info_row = info_r;
  board.info_error_row = infoerr_r;
  board.his_openf = openf;
  document.getElementById("hideP1").checked = hide1;
  document.getElementById("hideP2").checked = hide2;
  document.getElementById("hideP1").dispatchEvent(new Event('change'));
  document.getElementById("hideP2").dispatchEvent(new Event('change'));
  if (board.mode == 0 || board.mode == 3) {
    DEBUG("|| HISTORY LOAD\n"
      + "|| board.record_genmove: " + board.record_genmove + "\n"
      + "|| board.turn: " + board.turn + "\n"
      + "|| board.isstopboard: " + board.isstopboard + "\n"
      + "|| board.turnclr: " + board.turnclr + "\n"
      + "|| board.actlist: " + board.actlist + "\n"
      + "|| board.genlist: " + board.genlist + "\n"
      + "|| board.mode: " + board.mode + "\n"

      + "|| board.player: " + board.player + "\n"
      + "|| board.Players: " + board.Players + "\n"
      + "|| board.player_name: " + board.player_name + "\n"
      + "|| board.BoardSize: " + board.BoardSize + "\n"
      + "|| board.PiecesNum: " + board.PiecesNum + "\n"
      + "|| board.ini: " + board.ini + "\n"
      + "|| board.highlight: " + board.highlight + "\n"
      + "|| board.gameResult: " + board.gameResult + "\n"

      + "|| board.his_openf: " + board.his_openf + "\n"
      + "|| board.board_data: " + board.board_data + "\n"

      + "|| board.his_step: " + board.his_step + "\n"
    );
  } else {
    DEBUG("|| HISTORY.HTML SAVE\n"
      + "|| board.actlist: " + board.actlist + "\n"
      + "|| board.genlist: " + board.genlist + "\n"
      + "|| board.mode: " + board.mode + "\n"

      + "|| board.player: " + board.player + "\n"
      + "|| board.BoardSize: " + board.BoardSize + "\n"
      + "|| board.PiecesNum: " + board.PiecesNum + "\n"
      + "|| board.ini: " + board.ini + "\n"
      + "|| board.highlight: " + board.highlight + "\n"

      + "|| board.his_openf: " + board.his_openf + "\n"
      + "|| board.board_data: " + board.board_data + "\n"

      + "|| board.his_step: " + board.his_step + "\n"
    );
  }

  // history.html
  if (board.mode == 4) {
    const sw_div = document.createElement("div");
    sw_div.style = "position: relative;";

    const sw_lab = document.createElement("span");
    sw_lab.className += " i18n";
    sw_lab.setAttribute("i18next_key", "user_stdout");
    sw_lab.textContent = i18next.t("user_stdout");
    // sw_lab.style = "float: left;";

    const sw_lab1 = document.createElement("span");
    sw_lab1.className += " i18n";
    sw_lab1.setAttribute("i18next_key", "user_stderr");
    sw_lab1.textContent = i18next.t("user_stderr");
    // sw_lab1.style = "float: left;";

    const space = document.createElement("span");
    space.innerHTML = "&nbsp;&nbsp;&nbsp;"

    const sw = document.createElement("input");
    sw.id = "mui_sw";
    sw.className = "mui-switch mui-switch-animbg";
    sw.type = "checkbox";
    sw.checked = f;

    const sw1 = document.createElement("input");
    sw1.id = "mui_sw1";
    sw1.className = "mui-switch mui-switch-animbg";
    sw1.type = "checkbox";
    sw1.checked = f1;

    // sw_lab.appendChild(sw);
    // sw_lab1.appendChild(sw1);
    sw_div.appendChild(sw_lab);
    sw_div.appendChild(sw);
    sw_div.appendChild(space);
    sw_div.appendChild(sw_lab1);
    sw_div.appendChild(sw1);
    board.div_endgame_movelist.appendChild(sw_div);

    board.acttime = tbuf;

    while (div_endgame.firstChild) {
      let clone = div_endgame.firstChild.cloneNode(false);
      board.div_endgame_movelist.appendChild(clone);
      console.log(clone);
      div_endgame.removeChild(div_endgame.firstChild);
    }
    board.create_div_open_save();

    let sp = document.createElement("span");
    sp.append(openf);
    sp.style.float = "center";
    board.div_endgame_movelist.insertBefore(sp, board.div_endgame_movelist.childNodes[0]);

    //window.document.title = openf;
  }



  buf = null;
  buf2 = null;
  buf3 = null;
  turnclr = null;

  tbuf = null;
  data = null;
  //info = null;


  //走步區域
  document.querySelector('.path').innerHTML = "";
  var move_pos = null;
  //製作走步與highlight效果
  for (var i = 0; i < board.actlist.length; i++) {

    var strl = board.actlist[i];
    let text = strl.split(" ");
    let pos = text[1].split("-");
    var num = (i == index && board.highlight) ? 2 : 0;
    console.log("board.highlight:", board.highlight);
    console.log("now step:", i);

    board.div_path.append(
      board.new_observation_movelist_move(
        i,
        i % 2,
        "move" + (i % 2 + 1 + num),
        "(" + pos[0][0] + "," + pos[0][1] + ")⭢(" + + pos[1][0] + "," + pos[1][1] + ")"
      )
    );
    board.div_path.append(
      board.new_observation_movelist_move(
        i,
        i % 2,
        "time" + (i % 2 + 1),
        (parseInt(text[4]) / 1000).toFixed(1) + "/" + (parseInt(text[5]) / 1000).toFixed(1)
      )
    );
    
  }

  board.div_movelist.append(board.new_left_arrow(board.piece_row + 1, 0, 18, 30));
  board.div_movelist.append(board.new_right_arrow(board.piece_row + 1, 3, 18, 30));
  var left_arrow = board.div_movelist.getElementsByClassName("left_arrow")[0];
  var right_arrow = board.div_movelist.getElementsByClassName("right_arrow")[0];
  board.div_movelist.append(board.new_number_move(board.piece_row + 1, 1,
    board.movelist_font_size * 1.8, board.movelist_font_size * 5,
    "" + (index + 1) + "/" + (board.actlist.length))
  );
  if (board.actlist.length != 0) {
    left_arrow.onclick = function () {
      if (index == 0) {
        board.history_move(parseInt(board.actlist.length - 1));
      } else {
        board.history_move(parseInt(index - 1));
      }

    };
    right_arrow.onclick = function () {
      if (index == board.actlist.length - 1) {
        board.history_move(parseInt(0));
      } else {
        board.history_move(parseInt(index + 1));
      }
    };
  }
  board.div_path.scrollTop = (index - 5) * 24;
  left_arrow = null; right_arrow = null;

  //history.html
  if (board.mode == 4) {
    setPos(index + 1);
    var vs = new Array();
    if (board.board_data == "") {
      console.log(board.board_data);
      vs[0] = i18next.t("player_first"), vs[2] = i18next.t("player_second");
    } else {
      vs = board.board_data.split("* ")[2].split(" ");
    }
    let name_lab1 = document.createElement("span");
    name_lab1.textContent = vs[0];
    name_lab1.className+=" i18n";//i18n
    name_lab1.setAttribute("i18next_key", "player_first");

    name_lab1.style.float = "left";
    name_lab1.style.backgroundColor = "#ffa500";
    name_lab1.style.color = "white";
    name_lab1.style.fontSize = "18px";

    let lab_vs = document.createElement("span");
    lab_vs.textContent = "vs";
    lab_vs.style.paddingLeft = "10px";
    lab_vs.style.paddingRight = "10px";
    lab_vs.style.float = "left";
    lab_vs.style.color = "black";
    lab_vs.style.fontSize = "18px";

    let name_lab2 = document.createElement("span");
    name_lab2.textContent = vs[2];
    name_lab2.className+=" i18n";
    name_lab2.setAttribute("i18next_key", "player_second");
    name_lab2.style.float = "left";
    name_lab2.style.backgroundColor = "#5cc300";
    name_lab2.style.color = "white";
    name_lab2.style.fontSize = "18px";

    board.div_endgame_movelist.insertBefore(name_lab2, board.div_endgame_movelist.childNodes[0]);
    board.div_endgame_movelist.insertBefore(lab_vs, board.div_endgame_movelist.childNodes[0]);
    board.div_endgame_movelist.insertBefore(name_lab1, board.div_endgame_movelist.childNodes[0]);
  }

  window = board;

  DEBUG("his_init end");
}

var posarr = [0, 0];
// set textarea position
function setPos(ind) {
  console.log("setPos", ind);

  //scrollHeight all
  //clientHeight see
  let sw = document.getElementById("mui_sw");
  let sw1 = document.getElementById("mui_sw1");
  let textArea = document.getElementById("user_info");
  let textArea1 = document.getElementById("info_error");
  if (sw.checked == true) {
    let lineHeight = textArea.scrollHeight / board.info_row[board.info_row.length - 2];
    textArea.scrollTop = lineHeight * board.info_row[ind];
    posarr[0] = textArea.scrollTop;
  } else {
    textArea.scrollTop = posarr[0];
  }
  if (sw1.checked == true) {
    let lineHeight1 = textArea1.scrollHeight / board.info_error_row[board.info_error_row.length - 2];
    textArea1.scrollTop = lineHeight1 * board.info_error_row[ind];
    posarr[1] = textArea1.scrollTop;
  } else {
    textArea1.scrollTop = posarr[1];
  }
}
function focus_textbox() {
  DEBUG("textbox");
  board.his_create_name = true;
}
function blur_textbox() {
  board.his_create_name = false;
}

function _clear() {
  remove_rect();
  board.remove_div("content");
  // board.remove_div("scene");
  board.remove_div("button");
  if (document.getElementById("prompt_t")) {
    if (document.getElementById("prompt_t").hasChildNodes()) {
      if (document.getElementById("prompt_t").firstChild.id != "box_dialog") {
        document.getElementById("prompt_t").firstChild.remove();
      }
    }
  }
}

function _TurnArrow(index) {
  if (index == -1) {
    return;
  }
  let els = document.getElementsByClassName("whosearrow");

  console.log("whosearrow: player_clr" + (Number(index) + 1));

  Array.prototype.forEach.call(els, function (element) {
    element.style.display = "none";
    if (element.parentNode.id == "player_clr" + (Number(index) + 1)) {
      element.style.display = "block";
    }
  });
}

function _Die_pie(tar, capturePieceColor) {
  if (tar.hasChildNodes() == true) {
    let dieid, val;
    console.log(tar.firstChild);
    if (isUpperCase(tar.firstChild.firstChild.id)) {
      if (capturePieceColor == 1) {
        val = board.PCE_DIE.get("R");
        board.PCE_DIE.set("R", ++val);
        dieid = "die_P1_R" + val.toString();
      }
      else {
        val = board.PCE_DIE.get("B");
        board.PCE_DIE.set("B", ++val);
        dieid = "die_P1_B" + val.toString();
      }
    }
    else {
      if (capturePieceColor == 1) {
        val = board.PCE_DIE.get("r");
        board.PCE_DIE.set("r", ++val);
        dieid = "die_P2_R" + val.toString();
      }
      else {
        val = board.PCE_DIE.get("b");
        board.PCE_DIE.set("b", ++val);
        dieid = "die_P2_B" + val.toString();
      }
    }
    console.log(capturePieceColor, dieid);
    document.getElementById(dieid).style.opacity = 0.1;
  }

}

function isUpperCase(letter) {
  return /^[A-Z]$/.test(letter);
}

function isLowerCase(letter) {
  return /^[a-z]$/.test(letter);
}

function _Move(x1, y1, x2, y2, capturePieceColor) {
  if (!board.isstopboard) board.record_genmove = "";
  if (x2 == 6 || x2 == -1 || y2 == 6 || y2 == -1) return;
  var staid = "" + x1 + "_" + y1;
  var tarid = "" + x2 + "_" + y2;
  console.log(staid, tarid);
  var sta = document.getElementById(staid);
  var tar = document.getElementById(tarid);

  // move piece //
  _Die_pie(tar, capturePieceColor);
  var pie = sta.firstElementChild;
  var dpie = null;
  if (tar.hasChildNodes()) {
    dpie = tar.firstElementChild;
  }
  while (sta.firstChild) {
    sta.removeChild(sta.firstChild);
  }
  while (tar.firstChild) {
    tar.removeChild(tar.firstChild);
  }
  tar.appendChild(pie);

  // arrow //
  var set_top = 0;
  var set_left = 0;
  var arrow_class = "";
  switch (true) {
    case (x1 == x2 && y2 < y1):
      arrow_class = "u_arrow";
      set_top = remove_px(tar.style.top) + 36;
      set_left = remove_px(tar.style.left);
      break;
    case (x1 == x2 && y2 > y1):
      arrow_class = "d_arrow";
      set_top = remove_px(tar.style.top) - 36;
      set_left = remove_px(tar.style.left);
      break;
    case (y1 == y2 && x1 > x2):
      arrow_class = "l_arrow";
      set_top = remove_px(tar.style.top);
      set_left = remove_px(tar.style.left) + 36;
      break;
    case (y1 == y2 && x1 < x2):
      arrow_class = "r_arrow";
      set_top = remove_px(tar.style.top);
      set_left = remove_px(tar.style.left) - 36;
      break;
    case (x1 > x2 && y2 < y1):
      arrow_class = "ul_arrow";
      set_top = remove_px(tar.style.top) + 36;
      set_left = remove_px(tar.style.left) + 36;
      break;
    case (x1 < x2 && y2 < y1):
      arrow_class = "ur_arrow";
      set_top = remove_px(tar.style.top) + 36;
      set_left = remove_px(tar.style.left) - 36;
      break;
    case (x1 > x2 && y2 > y1):
      arrow_class = "dl_arrow";
      set_top = remove_px(tar.style.top) - 36;
      set_left = remove_px(tar.style.left) + 36;
      break;
    case (x1 < x2 && y2 > y1):
      arrow_class = "dr_arrow";
      set_top = remove_px(tar.style.top) - 36;
      set_left = remove_px(tar.style.left) - 36;
  }
  // arrow end //
  var div = document.createElement("div");
  div.id = "arrow";
  div.className = arrow_class;
  div.style.cssText = "width: " + 40 + "px";
  div.style.cssText += "height: " + 40 + "px";
  div.style.cssText += "top: " + set_top + "px";
  div.style.cssText += "left: " + set_left + "px";
  var pie_board = document.getElementById("div_piece_GST");
  pie_board.append(div);


}
// create save div
BaseBoard.prototype.create_div_open_save = function () {
  let bget = board.div_endgame_movelist;
  bget.style.width = "50%";
  let div = document.createElement("div");
  var style = "width:100%;";
  style += "position: relative;";
  style += "float: left;";
  div.setAttribute("style", style);
  let fopen = document.createElement("input");
  fopen.id = "myfile";
  fopen.type = "file";
  fopen.accept = ".txt";
  fopen.onchange = Open;
  fopen.style = "float: left;";

  let fname = document.createElement("input");
  fname.id = "filename";
  fname.type = "text";
  fname.style = "float: left;";
  fname.onclick = focus_textbox;
  fname.onblur = blur_textbox;

  let btn = document.createElement("input");
  btn.id = "submit";
  btn.value = "save";
  btn.type = "button";
  btn.style.top = "400px";
  btn.onclick = Save;
  btn.style = "float: left;";
  if (board.mode == 4) {
    div.appendChild(fopen);
  }
  div.appendChild(fname);
  div.appendChild(btn);
  bget.appendChild(div);

  bget.insertBefore(div, bget.childNodes[0]);
}

// create information areatext
function add_input() {
  board.create_div_open_save();
  console.log("add_input");
  let bget = board.div_endgame_movelist;
  let uinfo = document.createElement("textarea");
  uinfo.id = "user_info";

  style = "";
  style += "float: left;";
  style += "font-family: Courier New;";
  style += "position: relative;";
  uinfo.setAttribute("style", style);

  uinfo.style.width = "100%";
  uinfo.style.maxWidth = "100%";
  uinfo.style.resize = "none";
  uinfo.style.overflowX = "scroll";
  uinfo.style.overflowY = "scroll";
  uinfo.style.whiteSpace = "nowrap";
  uinfo.rows = "20";

  let uinfoerr = document.createElement("textarea");
  uinfoerr.id = "info_error";

  style = "";
  style += "float: left;";
  style += "font-family: Courier New;";
  style += "position: relative;";
  uinfoerr.setAttribute("style", style);


  uinfoerr.style.width = "100%";
  uinfoerr.style.maxWidth = "100%";
  uinfoerr.style.resize = "none";
  uinfoerr.style.overflowX = "scroll";
  uinfoerr.style.overflowY = "scroll";
  uinfoerr.style.whiteSpace = "nowrap";
  uinfoerr.rows = "20";

  bget.appendChild(uinfo);
  bget.appendChild(uinfoerr);
}

function remove_px(text) {
  var str = text.split('px');
  return parseInt(str[0]);
}
BaseBoard.prototype.keyEvent = function (event) {
  DEBUG("keyEvent " + board.mode);

  var key = event.keyCode || event.which;
  var keychar = String.fromCharCode(key);
  DEBUG(board.his_create_name, "key");
  if (board.his_create_name) {
    return;
  }
  if (key == this.exampleKey) {
    this.metaChar = true;
  }
  if (key != this.exampleKey) {
    if (this.metaChar) {
      this.metaChar = false;
    } else {
      DEBUG(key);
      switch (key) {
        case 65:
        case 87:
          // if (board.mode == 0) {
          if (parseInt(board.his_step - 1) >= 0) {
            board.history_move(parseInt(board.his_step - 1));
          } else {
            //max step
            board.history_move(parseInt(board.actlist.length - 1));
          }

          break;
        case 68:
        case 83:
          // if (board.mode == 0) {
          if (parseInt(board.his_step + 1) < board.actlist.length) {
            board.history_move(parseInt(board.his_step + 1));
          } else {
            //first step
            board.history_move(parseInt(0));
          }

          break;
      }
    }
  }
}

BaseBoard.prototype.metaKeyUp = function (event) {
  DEBUG("metaKeyUp");
  var key = event.keyCode || event.which;
  if (key == this.exampleKey) {
    this.metaChar = false;
  }
}

BaseBoard.prototype.history_move = function (item) {
  if (document.getElementById("set_mode") != null &&
    document.getElementById("set_mode").checked == false) {
    return;
  }
  DEBUG("history_move " + item);
  if (board.div_movelist.getElementsByClassName("label")[1] != null) {
    board.remove_div("left_arrow");
    board.remove_div("right_arrow");
    board.div_movelist.getElementsByClassName("label")[1].remove();
  }

  his_init(item);
  var moveid = -1;
  board.isaddmovelist = false;
  while (moveid < item) {
    moveid++;
    let list = board.actlist[moveid];
    let hist_move = "hist_move " + list.split(' ')[1] + " " + list.split(' ')[2] + " " + list.split(' ')[3] + " " + list.split(' ')[4] + " " + list.split(' ')[5] + " " + list.split(' ')[6];
    DEBUG("hm = " + list);
    DEBUG("mode = " + board.mode);
    Recv(hist_move);
  }
  board.turnclr = item % 2;
  _TurnArrow(board.turnclr);

  board.isaddmovelist = true;

  if (board.gameResult != "") Recv(board.gameResult);
  //if(board.mode == 2) board.mode = 1;
  DEBUG("history_move " + item + " end");
}
BaseBoard.prototype.board_init = function () {
  DEBUG("BB board_init");
  for (var row = 0; row < this.blank_row; row++) {
    for (var col = 0; col < this.blank_col; col++) {
      this.div_board.append(this.new_board_blank(row, col));
    }
  }

  this.div_board.append(this.new_board_escape("left", 1, 0));
  this.div_board.append(this.new_board_escape("right", 1, 7));
}
BaseBoard.prototype.path_init = function (move, start, end, ply, this_ply) {
}

BaseBoard.prototype.endgame_movelist_init = function (best_score, moves, best_index, url) {
  //DEBUG(moves);
  this.div_endgame_movelist.append(this.new_movelist_title("endgame"));//殘局語言設定
  var new_url = function (HIS) { return url + HIS; }
  //this.div_path = this.new_movelist(this.piece_row, 4);
  var row = 0;
  var move = null;
  var move_pos = 0;
  var max_ply = moves.length;

  var div_path = this.new_movelist(this.piece_row, 4.5);

  for (var i = 0; i < moves.length; i++) {
    let url = new_url(moves[i]);
    let s = moves[i].split(" ");
    let class_name = "end_move" + (i == best_index ? "_best" : "");
    div_path.append(move = this.new_endgame_movelist_move(i, 0, class_name, s[0], s[1], s[2]));
    move.onclick = function () { location.href = new_url(s[3]); };
    //if (i == (ply - 7)) move_pos = move.getAttribute("top");//style.top.substring(0, move.style.top.length - 2);
  }
  this.div_endgame_movelist.append(div_path);
  this.div_endgame_movelist.append(this.new_left_arrow(this.piece_row + 1, 0, 18, 30));
  this.div_endgame_movelist.append(this.new_right_arrow(this.piece_row + 1, 3, 18, 30));
  var str = best_score;//ply.toString() + "/" + max_ply.toString();
  this.div_endgame_movelist.append(this.new_number_move(this.piece_row + 1, 1, this.movelist_font_size * 1.8, this.movelist_font_size * 5, str));
  div_path.scrollTop = move_pos; //this.div_path.scrollHeight;
  this.div_endgame_movelist.getElementsByClassName("left_arrow")[0].onclick = function () { location.href = new_url(moves[best_index].split(" ")[3]); }
  this.div_endgame_movelist.getElementsByClassName("right_arrow")[0].onclick = function () { location.href = new_url(moves[best_index].split(" ")[3]); }
  //DEBUG(move_pos);
}

BaseBoard.prototype.remove_div = function (name) {
  var element = document.getElementsByClassName(name);
  while (element.length > 0) { element[0].remove(); }
}
BaseBoard.prototype.set_status = function (moves, ply, prev_url, next_url) {
}

function GSTBoard(BoardSize, PiecesNum, Players, mode) {
  DEBUG("|GSTBoard");
  DEBUG("|BoardSize = " + BoardSize);
  DEBUG("|PiecesNum = " + PiecesNum);
  DEBUG("|Players = " + Players);
  DEBUG("|Mode = " + mode);
  BaseBoard.call(this, BoardSize, BoardSize, PiecesNum, Players, "GST", mode);
  this.init();
}

GSTBoard.prototype = new BaseBoard();
GSTBoard.prototype.chess_board_init = function () {
  DEBUG("chess_board_init");
  for (i = 1; i <= this.piece_row; i++)
    this.div_board.append(this.new_bound(i, 0, (i - 1).toString()));
  for (i = 1; i <= this.piece_row; i++)
    this.div_board.append(this.new_bound(0, i, (i - 1).toString()));
  DEBUG("chess_board_init end");
}

GSTBoard.prototype.checkbox_init = function () {
  DEBUG("checkbox_init");
  // checkbox本體
  var checkbox_P2 = document.createElement("input");
  checkbox_P2.type = "checkbox";
  checkbox_P2.id = "hideP2";
  checkbox_P2.style.margin = "10px";
  checkbox_P2.disabled = true;
  checkbox_P2.checked = true;


  var checkbox_P1 = document.createElement("input");
  checkbox_P1.type = "checkbox";
  checkbox_P1.id = "hideP1";
  checkbox_P1.style.margin = "10px";
  checkbox_P1.disabled = true;


  // 判斷是否為觀戰模式，是才能使用
  if (this.mode == 4 || this.mode == 3) {
    checkbox_P2.disabled = false;
    checkbox_P1.disabled = false;
    checkbox_P2.checked = false;
  }

  // checkbox旁邊的文字
  var label_P2 = document.createElement("label");
  label_P2.htmlFor = "hideP2";
  label_P2.className += " i18n";
  label_P2.setAttribute("i18next_key", "hideP2");
  //label_P2.appendChild(document.createTextNode(" 隱藏對手棋子"));
  label_P2.innerHTML = i18next.t("hideP2");

  var label_P1 = document.createElement("label");
  label_P1.htmlFor = "hideP1";
  label_P1.className += " i18n";
  label_P1.setAttribute("i18next_key", "hideP1");
  //label_P1.appendChild(document.createTextNode(" 隱藏自己棋子"));
  label_P1.innerHTML = i18next.t("hideP1");

  // 將checkbox和label放進div
  this.checkbox.appendChild(checkbox_P2);
  this.checkbox.appendChild(label_P2);
  this.checkbox.appendChild(document.createElement("br"));
  this.checkbox.appendChild(checkbox_P1);
  this.checkbox.appendChild(label_P1);

  // 將div_checkBox加入到合適的位置
  this.div_piece.parentNode.insertBefore(this.checkbox, this.div_movelist);


  // checkbox_P2偵測
  checkbox_P2.addEventListener("change", function () {
    if (checkbox_P2.checked) {
      // 隱藏P2
      var pieces = document.querySelectorAll(
        ".GST_piece_P2_B, .GST_piece_P2_R"
      );

      pieces.forEach(function (piece) {
        var piece_id = piece.id;
        if (!["i"].includes(piece.id.charAt(1))) { //因為死的棋id為die_a所以要加上i才不會被算進去
          if (["a", "b", "c", "d"].includes(piece.id.charAt(0)) || ["e", "f", "g", "h"].includes(piece.id.charAt(0))) {
            piece.classList.add("GST_piece_P2");
            piece.classList.remove("GST_piece_P2_B", "GST_piece_P2_R");
          }
        }
      });
    } else {
      // 顯示P2
      var pieces = document.querySelectorAll(".GST_piece_P2");

      pieces.forEach(function (piece) {
        if (board.red_pce_id.includes(piece.id)){
          piece.classList.add("GST_piece_P2_R");
        }else{
          piece.classList.add("GST_piece_P2_B");
        }
        piece.classList.remove("GST_piece_P2");

      });
    }
  });

  // checkbox_P1偵測
  checkbox_P1.addEventListener("change", function () {
    if (checkbox_P1.checked) {
      // 隱藏P1
      var pieces = document.querySelectorAll(
        ".GST_piece_P1_B, .GST_piece_P1_R"
      );

      pieces.forEach(function (piece) {
        if (piece.id.length == 1) {
          if (["A", "B", "C", "D"].includes(piece.id.charAt(0)) || ["E", "F", "G", "H"].includes(piece.id.charAt(0))) {
            piece.classList.add("GST_piece_P1");
            piece.classList.remove("GST_piece_P1_B", "GST_piece_P1_R");
          }
        }

      });
    } else {
      // 顯示P1
      var pieces = document.querySelectorAll(".GST_piece_P1");

      pieces.forEach(function (piece) {
        if (board.red_pce_id.includes(piece.id)){
          piece.classList.add("GST_piece_P1_R");
        }else{
          piece.classList.add("GST_piece_P1_B");
        }
        // if (piece.id.length == 1) {
        //   if (["A", "B", "C", "D"].includes(piece.id.charAt(0))) {
        //     piece.classList.add("GST_piece_P1_B");
        //   } else if (["E", "F", "G", "H"].includes(piece.id.charAt(0))) {
        //     piece.classList.add("GST_piece_P1_R");
        //   }
        // }
        piece.classList.remove("GST_piece_P1");
      });
    }
  });
}

GSTBoard.prototype.piece_init = function () {
  DEBUG("piece_init");
  for (var row = 0; row < this.piece_row; row++) {
    for (var col = 0; col < this.piece_row; col++) {
      this.div_piece.append(document.getElementById(row + "_" + col));
    }
  }
  // init P1 piece
  let x = "R";
  let n = 0;
  for (let row = 4; row <= 5; row++) {
    for (let col = 1; col <= 4; col++) {
      DEBUG("P1>> " + col + " " + row);
      this.div_piece.append(this.new_board_piece(row, col, this.toClassName("P1_" + x), this.PCE_CODE[n]));
      n++;
    }
    x = "B";
  }

  // init P2 piece
  x = "R";

  for (let row = 1; row >= 0; row--) {
    for (let col = 4; col >= 1; col--) {
      DEBUG("P2>> " + col + " " + row);
      this.div_piece.append(this.new_board_piece(row, col, this.toClassName("P2_" + x), this.PCE_CODE[n]));
      n++;
    }
    x = "B";
  }

}

GSTBoard.prototype.screen_init = function () {
  DEBUG("screen_init");
  var m = Math.sqrt(this.PiecesNum);
  var n = parseInt(m);
  if (m != n) {
    n = n + 1;
  }
  var style = "";
  style = "";
  style += "top :" + (0 * (this.blank_size + this.border_width) + this.boundary_top) + "px;"
  style += "left:" + (n * (this.blank_size + this.border_width) + this.boundary_left) + "px;"
  this.div_board.setAttribute("style", style);

  style = "";
  style += "top :" + (0 * (this.blank_size + this.border_width) + this.piece_bound_top + this.boundary_top) + "px;"
  style += "left:" + (n * (this.blank_size + this.border_width) + this.piece_bound_left + this.boundary_left) + "px;"
  this.div_piece.setAttribute("style", style);

  style = "";
  style += "top :" + ((0 * (this.die_blank_size + this.border_width)) + (1 * (this.blank_size + this.border_width)) + this.boundary_top) + "px;"
  style += "left:" + (0.4 * (this.blank_size + this.border_width) + this.boundary_left) + "px;"
  this.div_P2_died.setAttribute("style", style);

  style = "";
  style += "top :" + (((this.PiecesNum / n + 3.5) * (this.die_blank_size + this.border_width)) + (1 * (this.blank_size + this.border_width)) + this.boundary_top) + "px;"
  style += "left:" + (0.4 * (this.blank_size + this.border_width) + this.boundary_left) + "px;"
  this.div_P1_died.setAttribute("style", style);

  style = "";
  style += "top :" + (0.5 * (this.blank_size + this.border_width) + this.boundary_top) + "px;"
  style += "left:" + ((n + 0.5 + this.piece_row + 1) * (this.blank_size + this.border_width) + this.boundary_left) + "px;"
  this.div_movelist.setAttribute("style", style);

  style = "";
  style += "top :" + (0.5 * (this.blank_size + this.border_width) + this.boundary_top) + "px;"
  style += "left:" + ((n + 1.2 + this.piece_row + 6) * (this.blank_size + this.border_width) + this.boundary_left) + "px;"
  this.div_endgame_movelist.setAttribute("style", style);
  //div_checkbox的位置
  style = "";
  style += "top :" + this.checkbox_top + "px;";
  style += "left:" + this.boundary_left + "px;";
  this.checkbox.setAttribute("style", style);
  //div_pieceCount的位置
  // style = "";
  // style += "top :" + this.pieceCount_top + "px;";
  // style += "left:" + this.pieceCount_left + "px;";
  // this.pieceCount.setAttribute("style", style);
  DEBUG("screen_init end");
}
let time_lab1 = null;
let time_lab2 = null;
GSTBoard.prototype.player_name_init = function () {
  DEBUG("player_name_init");
  let bget = this.div_endgame_movelist;
  let name_cube1 = null;
  let name_cube2 = null;
  var div_color = null;
  let name_lab1 = null;
  let name_lab2 = null;

  let turn = document.createElement("div");
  turn.className = "whosearrow";
  turn.textContent = "➜";
  turn.style.display = "none";

  div_color = document.createElement("div");
  div_color.style.left = "50px";
  div_color.style.top = "10px";
  div_color.style.width = "40px";
  div_color.style.height = "40px";
  div_color.style.backgroundColor = "gray";

  name_cube1 = div_color.cloneNode(true);
  name_cube2 = div_color.cloneNode(true);
  name_cube1.id = "name_cube1";
  name_cube2.id = "name_cube2";

  div1 = document.createElement("div");
  div1.id = "player_clr1";
  var style = "width:100%;";
  style += "height:50px;";
  style += "color:black;";
  style += "font-size:35px;";
  div1.setAttribute("style", style);

  div2 = document.createElement("div");
  div2.id = "player_clr2";
  div2.setAttribute("style", style);
  div1.style.top = "310px";
  div2.style.top = "370px";
  name_lab1 = document.createElement("div");
  name_lab1.textContent = "Player1：";
  name_lab1.id = "name_1"
  name_lab1.style.float = "left";
  name_lab1.style.fontSize = "35px";
  name_lab1.style.left = "110px";
  name_lab1.style.width = "300px";
  name_lab1.style.textAlign = "left";
  name_lab1.style.color = "gray";

  name_lab2 = document.createElement("div");
  name_lab2.textContent = "Player2：";
  name_lab2.id = "name_2"
  name_lab2.style.float = "left";
  name_lab2.style.fontSize = "35px";
  name_lab2.style.left = "110px";
  name_lab2.style.width = "300px";
  name_lab2.style.textAlign = "left";
  name_lab2.style.color = "gray";

  if (time_lab1 == null) {
    time_lab1 = document.createElement("div");
    time_lab1.id = "time_1";
    time_lab1.style.cssText = "float:left;font-size:35px;left:450px";
    document.body.appendChild(time_lab1);
  }

  if (time_lab2 == null) {
    time_lab2 = document.createElement("div");
    time_lab2.id = "time_2";
    time_lab2.style.cssText = "float:left;font-size:35px;left:450px";
    document.body.appendChild(time_lab2);
  }

  bget.appendChild(div1);
  bget.appendChild(div2);

  div1.appendChild(turn, div1.childNodes[0]);
  div1.appendChild(name_cube1, div1.childNodes[0]);
  div1.appendChild(name_lab1, div1.childNodes[0]);
  div1.appendChild(time_lab1, div1.childNodes[0]);

  div2.appendChild(turn.cloneNode(true), div2.childNodes[0]);
  div2.appendChild(name_cube2, div2.childNodes[0]);
  div2.appendChild(name_lab2, div2.childNodes[0]);
  div2.appendChild(time_lab2, div2.childNodes[0]);

  DEBUG("player_name_init end");

}
GSTBoard.prototype.add_playerName = function (ColorOrder) {
  if (document.getElementById("name_1")) {
    document.getElementById("name_1").textContent += this.player_name[1];
    let color = "#ffa500";
    document.getElementById("name_1").style.color = color;
    document.getElementById("name_cube1").style.background = color;
  }
  if (document.getElementById("name_2")) {
    document.getElementById("name_2").textContent += this.player_name[2];
    let color = "#5cc300";
    document.getElementById("name_2").style.color = color;
    document.getElementById("name_cube2").style.background = color;
  }

}

GSTBoard.prototype.died_piece_init = function () {
  DEBUG("died_piece_init");
  this.P1_died_init();
  this.P2_died_init();
  DEBUG("died_piece_init end");
}

GSTBoard.prototype.P1_died_init = function () {
  DEBUG("P1_died_init");
  this.div_P1_died.append(this.new_die_piece(0, 0, this.PCE_TYPE["P1_R"].className, "P1_R1"));
  this.div_P1_died.append(this.new_die_piece(0, 1, this.PCE_TYPE["P1_R"].className, "P1_R2"));
  this.div_P1_died.append(this.new_die_piece(0, 2, this.PCE_TYPE["P1_R"].className, "P1_R3"));
  this.div_P1_died.append(this.new_die_piece(0, 3, this.PCE_TYPE["P1_R"].className, "P1_R4"));
  this.div_P1_died.append(this.new_die_piece(1, 0, this.PCE_TYPE["P1_B"].className, "P1_B1"));
  this.div_P1_died.append(this.new_die_piece(1, 1, this.PCE_TYPE["P1_B"].className, "P1_B2"));
  this.div_P1_died.append(this.new_die_piece(1, 2, this.PCE_TYPE["P1_B"].className, "P1_B3"));
  this.div_P1_died.append(this.new_die_piece(1, 3, this.PCE_TYPE["P1_B"].className, "P1_B4"));
  DEBUG("P1_died_init end");
}

GSTBoard.prototype.P2_died_init = function () {
  DEBUG("P2_died_init");
  this.div_P2_died.append(this.new_die_piece(0, 0, this.PCE_TYPE["P2_B"].className, "P2_B1"));
  this.div_P2_died.append(this.new_die_piece(0, 1, this.PCE_TYPE["P2_B"].className, "P2_B2"));
  this.div_P2_died.append(this.new_die_piece(0, 2, this.PCE_TYPE["P2_B"].className, "P2_B3"));
  this.div_P2_died.append(this.new_die_piece(0, 3, this.PCE_TYPE["P2_B"].className, "P2_B4"));
  this.div_P2_died.append(this.new_die_piece(1, 0, this.PCE_TYPE["P2_R"].className, "P2_R1"));
  this.div_P2_died.append(this.new_die_piece(1, 1, this.PCE_TYPE["P2_R"].className, "P2_R2"));
  this.div_P2_died.append(this.new_die_piece(1, 2, this.PCE_TYPE["P2_R"].className, "P2_R3"));
  this.div_P2_died.append(this.new_die_piece(1, 3, this.PCE_TYPE["P2_R"].className, "P2_R4"));
  DEBUG("P2_died_init end");
}


GSTBoard.prototype.piece_click = function () {
  DEBUG("GST click ", board.player, board.tmp);

}
GSTBoard.prototype.shape_mouse_click = function () {
  DEBUG("GST shape_mouse_click");
  DEBUG("turn " + board.turn);
  //blank
  if (board.turn == 2) { //設定ini棋子位置
    if (!this.hasChildNodes()) {//空格

    }//棋子
    else if ((this.firstChild.firstChild.className.includes("GST_piece_P1"))) {
      if (board.after_blank == null) {//此為第一次
        this.appendChild(add_rect_src(38, 38, 0.7, 0.7, "orange_rect", null));
        board.after_blank = document.getElementById(this.id);
        DEBUG("|| " + board.after_blank.id);
        DEBUG("3");
      }
      else {//此為第二次
        board.remove_div("orange_rect");
        var sta = document.getElementById(board.after_blank.id);
        var tar = document.getElementById(this.id);
        let temp = sta.firstChild.firstChild.className;
        console.log("temp: ", temp);
        sta.firstChild.firstChild.className = tar.firstChild.firstChild.className;
        tar.firstChild.firstChild.className = temp;
        board.after_blank = null;
        DEBUG("4");
      }

    }
  }
  else if (board.turn == 1) {
    if (!this.hasChildNodes()) {//空格
      if (board.after_blank == null) {//第一次
        DEBUG("0");
      }
      else if (this.lastChild.className == "rect") {//第二次
        while (document.getElementById("content") != null) {
          document.getElementById("content").remove();
        }
        board.after_blank.firstChild.style.backgroundColor = "#00000000";
        board.remove_div("rect");
        board.remove_div("rect_src");
        board.remove_div("rect_src_select");
        board.turn = 0;
        var pos = NumPosToEnPos(board.after_blank.id) + " " + NumPosToEnPos(this.id);
        board.after_blank = null;
        DEBUG("pos >> " + pos);
        board.socket.send(pos);
        DEBUG("1");
      }
    }
    else {
      if (board.after_blank == null) {//此為第一次
        DEBUG("click first");
        console.log(this);
        let p = "P1"; //used for check 友軍
        let dis = [-1, 1, -1, 1]; // 上下左右 位移量

        let isSelect = false;
        for (let pieceCode of board.select_blanks) {
          if (this.firstChild.lastChild.id == pieceCode) {
            isSelect = true;
            break;
          }
        }
        if (!isSelect) return;

        board.remove_div("rect_src_select");
        this.appendChild(add_rect_src(38, 38, 0.7, 0.7, "select", null));
        board.after_blank = document.getElementById(this.id);

        let chess = board.after_blank.id.split("_");
        let up = parseInt(chess[1]) + dis[0];
        let down = parseInt(chess[1]) + dis[1];
        let left = parseInt(chess[0]) + dis[2];
        let right = parseInt(chess[0]) + dis[3];
        let r = parseInt(board.blank_row);
        let c = parseInt(board.blank_col);
        // 上 路徑
        if (up >= 0 && up < r) {
          let posid = parseInt(chess[0]) + "_" + up;
          if (is_barrier(posid, p) == 0) {
            document.getElementById(posid).appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "NORTH"));
          }
        }
        // 下
        if (down >= 0 && down < r) {
          let posid = parseInt(chess[0]) + "_" + down;
          if (is_barrier(posid, p) == 0) {
            document.getElementById(posid).appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "SOUTH"));
          }
        }
        // 左
        if (left >= 0 && left < c) {
          let posid = left + "_" + parseInt(chess[1]);
          if (is_barrier(posid, p) == 0) {
            document.getElementById(posid).appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "WEST"));
          }
        }
        // 右
        if (right >= 0 && right < c) {
          let posid = right + "_" + parseInt(chess[1]);
          if (is_barrier(posid, p) == 0) {
            document.getElementById(posid).appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "EAST"));
          }
        }
        if (board.after_blank.firstChild.lastChild.className.includes("B")) {
          //escape from left cornor
          if (up == -1 && left == -1) {
            document.getElementById("8_8_left").appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "WEST"));
          }
          //escape from right cornor
          if (up == -1 && right == 6) {
            document.getElementById("8_8_right").appendChild(add_rect_src(38, 38, 0.7, 0.7, "rect", "EAST"));
          }
        }

      }
      else {//第二次
        DEBUG("click second");
        // 選擇其他棋子
        if (this.id == board.after_blank.id) {
          if (board.select_blanks.length < 2) return;

          board.remove_div("rect_src_select");
          board.remove_div("rect");

          for (let pieceCode of board.select_blanks) {
            console.log(pieceCode);
            document.getElementById(pieceCode).parentNode.parentNode.appendChild(add_rect_src(38, 38, 0.7, 0.7, "select", null));
          }
          board.after_blank = null;
        }
        // 移動
        else if (this.childNodes.length >= 1 && this.lastChild.className == "rect") {
          let dirStr = this.lastChild.id;
          while (document.getElementById("content") != null) {
            document.getElementById("content").remove();
          }
          board.after_blank.firstChild.style.backgroundColor = "#00000000";
          board.select_blanks = new Array();
          board.remove_div("rect");
          board.remove_div("rect_src_select");
          board.turn = 0;
          // var pos = NumPosToEnPos(parseInt(board.after_blank.id.split("_")[0]-1)*board.blank_row + parseInt(board.after_blank.id.split("_")[1])) + " " + NumPosToEnPos(parseInt(this.id.split("_")[0]-1)*board.blank_row + parseInt(this.id.split("_")[1]));
          let sendstr = "MOV:" + board.after_blank.firstChild.firstChild.id.toUpperCase() + "," + dirStr;
          board.after_blank = null;
          console.log(sendstr);
          board.socket.send(sendstr);
          DEBUG("5");
        }
      }
    }
  }
}

/* mouse event */
var add_value = [-1, 1];
var push_in = -1;
var push_s = "";
var S_NUM = ["０", "１", "２", "３", "４", "５", "６", "７", "８"];
var E_NUM = ["", "ａ", "ｂ", "ｃ", "ｄ"];
var S_NUM_url = ["0", "1", "2", "3", "4", "5", "6", "7", "8"];
var E_NUM_url = ["", "a", "b", "c", "d"];
var score = [
  ["將", ["帥", "仕", "相", "俥", "傌", "炮", ""]],
  ["士", ["仕", "相", "俥", "傌", "炮", "兵", ""]],
  ["象", ["相", "俥", "傌", "炮", "兵", ""]],
  ["車", ["俥", "傌", "炮", "兵", ""]],
  ["馬", ["傌", "炮", "兵", ""]],
  ["包", ["帥", "仕", "相", "俥", "傌", "炮", "兵", ""]],
  ["卒", ["帥", "兵", ""]],
  ["帥", ["將", "士", "象", "車", "馬", "包", ""]],
  ["仕", ["士", "象", "車", "馬", "包", "卒", ""]],
  ["相", ["象", "車", "馬", "包", "卒", ""]],
  ["俥", ["車", "馬", "包", "卒", ""]],
  ["傌", ["馬", "包", "卒", ""]],
  ["炮", ["將", "士", "象", "車", "馬", "包", "卒", ""]],
  ["兵", ["將", "卒"]]
];
var red_set = new Set(["帥", "仕", "相", "俥", "傌", "炮", "兵"]);
var black_set = new Set(["將", "士", "象", "車", "馬", "包", "卒"]);
var PCE_POS = new Map();

var pie_tmp = null;
var after_blank = null;
var Score_map = set_score();
function set_score() {
  var s_map = new Map(score);
  //.log(s_map);
  return s_map;
}
function create_div(w, h, t, l) {
  var div = document.createElement("div");
  div.className = "rect";
  //div.className = "move_mark";
  div.style.cssText = "width: " + w + "px";
  div.style.cssText += "height: " + h + "px";
  div.style.cssText += "top: " + t + "px";
  div.style.cssText += "left: " + l + "px";
  //console.log("create_div end", w, h, t, l);
  return div;
}
function add_rect_src(w, h, t, l, type, dir) {
  var div = document.createElement("div");
  if (type == "select") {
    div.className = "rect_src_select";
  } else if (type == "orange_rect"){
    div.className = "orange_rect";
  } else {
    div.className = "rect";
    div.id = dir
  }
  //div.className = "move_mark";
  div.style.cssText = "width: " + w + "px";
  div.style.cssText += "height: " + h + "px";
  div.style.cssText += "top: " + t + "px";
  div.style.cssText += "left: " + l + "px";
  //DEBUG("create_div end", w, h, t, l);
  return div;
}
function is_barrier(id, p) {
  let dst = document.getElementById(id);
  if (dst.firstElementChild != null) {
    if (dst.firstElementChild.firstElementChild.className.includes(p)) {
      return 1;
    }
  }
  return 0;
}


BaseBoard.prototype.remove_div = function (name) {
  var element = document.getElementsByClassName(name);
  while (element.length > 0) { element[0].remove(); }
}


function move_C(x, y, text) {
  var flag_C = -1;
  var i = 0;
  for (i = 1; i < 4; i++) {
    if ((x - i) > 0) {
      var push_s = E_NUM_url[x - i] + "_" + S_NUM_url[y];
      var flag = is_barrier(push_s, text);
      if (flag == 1 || flag == -1) { flag_C = 1; break; }
    }
  }
  if (flag_C == 1) {
    for (var j = i + 1; j < 4; j++) {
      if ((x - j) > 0) {
        var push_s = E_NUM_url[x - j] + "_" + S_NUM_url[y];
        var flag = is_barrier(push_s, text);
        //var bbb = document.getElementById(push_s).firstElementChild;
        if (flag == 1) { break; }
        if (flag == -1) {
          //console.log(push_s, i, j);
          var div = create_div(38, 38, 0.7, 0.7);
          document.getElementById(push_s).appendChild(div);
          break;
        }
      }
    }
  }
  flag_C = 0;
  for (i = 1; i < 4; i++) {
    if ((x + i) <= 4) {
      var push_s = E_NUM_url[x + i] + "_" + S_NUM_url[y];
      var flag = is_barrier(push_s, text);
      if (flag == 1 || flag == -1) { flag_C = 1; break; }
    }
  }
  if (flag_C == 1) {
    for (var j = i + 1; j < 4; j++) {
      if ((x + j) <= 4) {
        var push_s = E_NUM_url[x + j] + "_" + S_NUM_url[y];
        var flag = is_barrier(push_s, text);
        //var bbb = document.getElementById(push_s).firstElementChild;
        if (flag == 1) { break; }
        if (flag == -1) {
          //console.log(push_s, i , j);
          var div = create_div(38, 38, 0.7, 0.7);
          document.getElementById(push_s).appendChild(div);
          break;
        }
      }
    }
  }
  flag_C = 0;
  for (i = 1; i < 8; i++) {
    if ((y - i) > 0) {
      var push_s = E_NUM_url[x] + "_" + S_NUM_url[y - i];
      var flag = is_barrier(push_s, text);
      if (flag == 1 || flag == -1) { flag_C = 1; break; }
    }
  }
  if (flag_C == 1) {
    for (var j = i + 1; j < 8; j++) {
      if ((y - j) > 0) {
        var push_s = E_NUM_url[x] + "_" + S_NUM_url[y - j];
        var flag = is_barrier(push_s, text);
        //var bbb = document.getElementById(push_s).firstElementChild;
        if (flag == 1) { break; }
        if (flag == -1) {
          //console.log(push_s, i, j);
          var div = create_div(38, 38, 0.7, 0.7);
          document.getElementById(push_s).appendChild(div);
          break;
        }
      }
    }
  }
  flag_C = 0;
  for (i = 1; i < 8; i++) {
    if ((y + i) <= 8) {
      var push_s = E_NUM_url[x] + "_" + S_NUM_url[y + i];
      var flag = is_barrier(push_s, text);
      if (flag == 1 || flag == -1) { flag_C = 1; break; }
    }
  }
  if (flag_C == 1) {
    for (var j = i + 1; j < 8; j++) {
      if ((y + j) <= 8) {
        var push_s = E_NUM_url[x] + "_" + S_NUM_url[y + j];
        var flag = is_barrier(push_s, text);
        //var bbb = document.getElementById(push_s).firstElementChild;
        if (flag == 1) { break; }
        if (flag == -1) {
          //console.log(push_s, i ,j);
          var div = create_div(38, 38, 0.7, 0.7);
          document.getElementById(push_s).appendChild(div);
          break;
        }
      }
    }
    flag_C = 0;
  }
  //console.log("move_C return");
  return;
}
function remove_rect() {
  board.remove_div("blue_rect");
  board.remove_div("black_rect");
  board.remove_div("red_rect");
  board.remove_div("orange_rect");
  var arow = document.getElementById("arrow");
  if (arow != null) { arow.remove(); }
}
function OS() {
  board.os_type = (navigator.platform.indexOf("Win", 0) != -1) ? '\r\n' : '\n';
}
function Save() {
  var satext = "";
  var datacr = new Array();
  datacr = board.board_data.split('* ');
  console.log(datacr);
  //"This is TEMPORARILY file. You can use it for DEBUG.";
  //20190721
  if (/\n/.test(datacr[0]) == false) {
    satext += "This is TEMPORARILY file. You can use it for DEBUG." + board.os_type;
  }

  for (i = 1; i <= 10; i++) {
    satext += "* " + datacr[i] + board.os_type;
  }
  
  console.log(satext);
  
  var index = 1;
  var flag = false;
  for (var i = 0; i <= board.his_step; i++) {
    if (i % 2 == 0) {
      satext += "* " + index + ". " + board.genlist[i].split(" ")[1] + "," + board.genlist[i].split(" ")[2];
      board.eatlist.push(board.genlist[i].split(" ")[3]);
      flag = true;
    } else {
      satext += " " + board.genlist[i].split(" ")[1].toUpperCase() + "," + board.genlist[i].split(" ")[2] + board.os_type;
      board.eatlist.push(board.genlist[i].split(" ")[3]);
      flag = false;
      index++;
    }
  }
  if (flag) {
    satext += board.os_type;
  }
  satext += "* Comment 0 0";
  satext += board.os_type;
  //time
  board.acttime[0] = board.acttime[0].replace(/\r?\n/g, "");
  satext += "0. " + board.acttime[0].split(board.split_str)[0].split(' ')[1] + board.os_type;
  index = 1;
  for (var i = 1; i < (board.his_step + 2); i++) {
    board.acttime[i] = board.acttime[i].replace(/\r?\n/g, "");
    satext += index + ". " + board.acttime[i].split(board.split_str)[0].split(' ')[1] + board.os_type;
    index++;
  }
  //capture piece color
  for (let i = 0; i <= board.his_step; i++) {
    satext += i + ". " + board.eatlist[i] + board.os_type;
  }

  satext += board.os_type;
  satext += "# #" + board.os_type;
  satext += "# #" + board.os_type;
  satext += "###" + board.os_type;
  var txtblob = new Blob([satext], { type: "text/plain;charset=utf-8" });
  var textarea = document.getElementById("filename").value;
  var filename = "";

  if (textarea != "") {
    filename = textarea + ".txt";
  }
  else {
    filename = "board.txt";
  }
  let url = window.URL.createObjectURL(txtblob);

  let downloadNode = document.createElement("a");
  downloadNode.style.display = "none";
  downloadNode.href = url;
  downloadNode.download = filename;

  document.body.appendChild(downloadNode);
  downloadNode.click();
  window.URL.revokeObjectURL(url);
}
var isDEBUG = true;
function DEBUG(str) {
  if (isDEBUG == true) {
    console.log(str);
  }
}

console.log("js loading...");